
-----------------------------------------------------------------------------
  More details on the bugs listed below can be found by using the bug number
  indicated in the following URL:

    http://bugs.proftpd.org/show_bug.cgi?id=N

  where `N' is the bug number.

  If the issue listed below mentions "Issue" instead of "Bug", the number
  there references a GitHub issue, which can be found using a URL like:

    https://github.com/proftpd/proftpd/issues/N

  where `N' is the issue number.
-----------------------------------------------------------------------------

1.3.9rc3 - Released 11-Dec-2024
--------------------------------
- Issue 1785 - Bad handling of lack of extended attributes leads to SFTP out of
  memory error.
- Issue 1780 - Using mod_facl and mod_vroot at same time causes unexpected
  permissions issues.
- Issue 1529 - mod_sftp_sql logs "header value too long" due to unexpected key
  header text.
- Issue 1792 - SFTP statvfs extension fails when mod_vroot is in use.
- Issue 1798 - Implement limits@openssh.com SFTP extension.
- Issue 1806 - Implement SFTPAuthPublicKeys directive for configuring the list
  of public key algorithms allowed for authentication.
- Issue 1819 - Stack trace changing to directory with DisplayChdir file using
  %F variable on a large filesystem.
- Issue 1836 - Remove inherited supplemental groups when started with root
  privileges.
- Issue 1839 - SSH ECDSA host key algorithms not being used as expected despite
  configuring appropriate key.
- Issue 1840 - RADIUS Message-Authenticator verification failed with ProFTPD
  mod_radius.
- Issue 1830 - Supplemental group inheritance grants unintended access to
  GID 0 due to lack of supplemental groups from mod_sql.

1.3.9rc2 - Released 19-Dec-2023
--------------------------------
- Issue 1730 - 1.3.9rc1 mod_sftp fails to compile if EVP_chacha20 is
  unavailable, as when using older OpenSSL versions.
- Issue 1746 - Error resolving DNS name for implicit "server config" vhost
  leads to DelayTable not being found.
- Issue 1749 - Log message for exceeding quota does not include the
  user/group/class quota type.
- Issue 1756 - Build system fails for specific module names.
- Issue 1760 - mod_sftp is affected by "Terrapin" Prefix Truncation Attacks in
  SSH Specification (CVE-2023-48795).
- Issue 1770 - Using FTPS after upgrading from 1.3.8a to 1.3.8b leads to crash.
- Issue 1775 - Add support for logging SFTP ciphers/algorithms in SQL databases.
- Issue 1764 - Using mod_quotatab hard limits in combination with mod_vroot
  causes inaccessible files.

1.3.9rc1 - Released 08-Oct-2023
--------------------------------
- Bug 4494 - mod_tls build fails for OpenSSL before 1.1.x.
- Issue 1570 - mod_sftp should advertise standard extensions for protocol
  version 3.
- Issue 1569 - mod_sftp "check-file" extension uses wrong block size when
  offset and length are specified.
- Issue 379 - Use JSON for Controls protocol messages.
- Issue 1114 - Provide richer exit status values for ftpdctl for better
  scripting.
- Issue 1581 - mod_sftp fails to handle SFTP requests to truncate files to
  zero size.
- Issue 1584 - mod_sftp improperly handles SFTP WRITE requests for files opened
  for appending.
- Bug 4495 - Enforce requirement of preceding RewriteCondition for RewriteRule
  directives to avoid confusion.
- Issue 1568 - Build-time detection of Linux POSIX ACL support broken since
  1.3.8rc2.
- Issue 1590 - Unable to load mod_rewrite as a dynamic module due to
  incomplete/missing library linker flags.
- Issue 1597 - <Class> section is allowed to be in <Global>, but From directive
  is not.
- Issue 535 - Implement LogFormat variable for data transfer average speed.
- Issue 1596 - Optimize per-connection file I/O when reading SFTPHostKey from
  disk.
- Issue 1610 - ProFTPD does not detect FIPS when using OpenSSL 3.x built with
  FIPS support.
- Issue 1617 - ExtendedLog SSH, SFTP classes not working as expected.
- Issue 1623 - Reduce latency due to signal handling in the daemon process.
- Issue 1626 - SSH key exchange requests should be classifed into the "SEC"
  ExtendedLog class.
- Issue 1630 - Update mod_exec to use the Jot API for resolving variables.
- Issue 1636 - Use system TCP backlog value by default.
- Issue 1639 - Gracefully handle directory creation requests when the directory
  already exists.
- Issue 1646 - mod_sftp does not handle multiple concurrent open file
  handles/transfers well for logging.
- Issue 1661 - Remove asynchronous FTP responses emitted while computing digest
  values.
- Issue 1679 - "TLSRequired off" plus Protocols directive causes mod_tls to
  terminate the session abruptly.
- Issue 1640 - Support terminating connection after USER command when TLS is
  required.
- Issue 1676 - Support OPTS commands for querying configured policy for resumed
  uploads, downloads.
- Issue 1686 - MaxStoreFileSize for single user not properly honored for SFTP
  uploads.
- Issue 1689 - mod_tls fails to compile against OpenSSL 3.0.8 due to missing
  ENGINE_METHOD_ flags.
- Issue 1688 - DisplayChdir using absolute path should work properly with
  DefaultRoot.
- Issue 1659 - Unknown named connection error when using different SQL backends.
- Issue 1697 - mod_sql is not properly closing all named backend connections on
  session exit.
- Issue 1700 - Clients should be disconnected when unable to be added to the
  ScoreboardFile.
- Issue 1701 - Support injecting random delay when clients connect via
  DelayOnEvent.
- Issue 1694 - SSH key exchanges fail unexpectedly with "unable to write X
  bytes of raw data" errors due to small ProFTPD buffer.
- Issue 1118 - Support OpenSSH FIDO security keys in mod_sftp.
- Issue 1678 - High session memory usage caused by SFTP outgoing data buffering.
- Issue 1683 - Out-of-bounds buffer read when handling FTP commands.
- Issue 1716 - Support obtaining default UID/GID values for AD directories in
  mod_ldap.
- Issue 1712 - SFTP algorithm settings in <Global> section not being used.
- Issue 1433 - Update upload progress in scoreboard when throttling.
- Issue 1721 - Null pointer reference encountered for FTPS connection due to
  config parser ignoring Include file problem.
- Issue 456 - Support the chacha20-poly1305@openssh.com SSH cipher.
- Issue 1562 - mod_auth_otp should require per-user OTP entries by default.

1.3.8 - Released 04-Dec-2022
--------------------------------
- Issue 1488 - 1.3.8rc4 failing to build mod_sftp with OpenSSL 1.1.0 due to
  X448 check.
- Issue 1494 - 1.3.8rc4 failing to build on Solaris due to missing type
  declarations.
- Issue 1500 - mod_ifsession doesn't change the effect of SFTPMaxChannels.
- Issue 1533 - mod_tls module unexpectedly allows TLS handshake after
  authentication in some configurations.
- Issue 1528 - Disable FSCachePolicy by default.
- Issue 1539 - Avoid logging "session closed" messages unless there is a
  corresponding "session opened" log message, to avoid user confusion.
- Issue 1550 - Implement support for the CSID FTP command.
- Bug 4491 - unable to verify signed data: signature type 'rsa-sha2-512' does
  not match publickey algorithm 'ssh-rsa'.
- Issue 1560 - mod_auth_otp improperly allows keyboard-interactive logins for
  users lacking OTP entries.

1.3.8rc4 - Released 23-Jul-2022
--------------------------------
- Issue 1434 - mod_sftp should fail on startup when SFTP and TLS are both
  enabled for a vhost.
- Issue 1440 - DelayTable not properly using documented default value.  This
  is a regression caused by the changes for Bug#4020.
- Issue 1444 - Support customizing SSH ciphers, digests, key exchanges via
  SFTPClientMatch.
- Issue 1448 - Ensure that mod_sftp algorithms work properly with OpenSSL 3.x.
- Issue 1445 - BanOnEvent BadProtocol triggers segfault.
- Issue 1439 - SFTP "check-file" implementation computes incorrect results.
- Issue 1457 - Implement SFTPHostKeys directive for configuring the SSH host
  key algorithms.
- Issue 1437 - Implement the "curve448-sha512" SSH key exchange algorithm.
- Issue 1472 - Include directive broken when using wildcards for directory
  components.
- Bug 4485 - mod_sftp fails to build using OpenSSL 1.0.x: undefined reference
  to `EVP_MD_CTX_reset'.
- Issue 1476 - Reload after omitting explicit ModulePath value causes fatal
  module load failures.

1.3.8rc3 - Released 23-Apr-2022
--------------------------------
- Issue 1323 - Support SSH hostkey rotation via OpenSSH extensions.
- Issue 1325 - NLST does not behave consistently for relative paths.
- Bug 3759 - Support AES Galois Counter Mode (AES-GCM) in SSH.  Support for
  the "aes128-gcm@openssh.com" and "aes256-gcm@openssh.com" ciphers has been
  added to mod_sftp.
- Issue 1333 - Implement an LDAPConnectTimeout directive, to configure the
  timeout used when connecting to LDAP servers.
- Issue 1330 - Implement OpenSSH "Encrypt-Then-MAC" (ETM) algorithm extensions.
- Issue 1346 - Implement AllowForeignAddress class matching for passive data
  transfers.
- Issue 1353 - Implement support for PCRE2.
- Bug 4466 - ProFTPD won't start with several locales.
- Issue 1367 - Auth sources providing space-bearing user/group names cause
  compliance issues with MLSD/MLST responses.
- Bug 4467 - DeleteAbortedStores removes successfully transferred files
  unexpectedly.
- Issue 1383 - Omit EPRT/EPSV from FEAT response when denied by <Limit>
  configuration.
- Issue 1379 - Support uploading to symlinked files.
- Issue 1401 - Keepalive socket options should be set using IPPROTO_TCP, not
  SOL_SOCKET.
- Issue 1402 - TCP keepalive SocketOptions should apply to control as well as
  data connection.
- Issue 1396 - ProFTPD always uses the same PassivePorts port for first
  transfer.
- Issue 1410 - mod_sftp needs to handle unknown SSH messages in an
  RFC-compliant manner, ignoring rather than disconnecting.
- Issue 1418 - Improve handling of some globally applied configuration
  directives.
- Issue 1369 - Name-based virtual hosts not working as expected after upgrade
  from 1.3.7a to 1.3.7b.

1.3.8rc2 - Released 29-Aug-2021
--------------------------------
- Bug 4401 - mod_sftp crashes when handling aes256-ctr OpenSSH-specific key
  with some old OpenSSL versions.
- Issue 1273 - Improve mod_tls log messages for unsupported older TLS protocol
  requests.
- Issue 1284 - Fix memory disclosure to RADIUS servers by mod_radius.
- Issue 1282 - Properly handle <VirtualHost> sections that use interface/device
  names.
- Bug 4315 - mod_ifsession fails to reset directory config lookup after
  <Directory> section merges.
- Issue 1296 - Support <Limit> configurations for HELP command.
- Issue 1300 - PCRE expressions with capture groups are not being handled
  properly.
- Issue 1307 - AuthUserFile permissions check fails during SIGHUP, causing
  ProFTPD to stop.
- Issue 1286 - Add support for the libidn2 library, over libidn, for e.g.
  mod_rewrite mappings.
- Bug 4443 - Changed the default behavior of mod_tls, such that TLS
  renegotiations on control/data connections are not requested by default.
  TLS renegotiations have a long and sordid history; many SSL/TLS libraries no
  longer implement them, or disable them by default.
- Issue 1319 - mod_auth_otp should honor RequireTableEntry semantics for SFTP
  logins.

1.3.8rc1 - Released 13-Jun-2021
--------------------------------
- Issue 1063 - FTPS data transfers using TLSv1.3 might segfault when session
  tickets cannot be decrypted.
- Issue 1070 - Implement support for Redis 6.x AUTH semantics.
- Issue 1068 - Define an OpenSSL API version compatibility macro, currently
  set to OpenSSL 1.0.0 and later.
- Bug 4405 - Memory use-after-free in mod_sftp causes unexpected
  login/authentication issues.
- Bug 4402 - Inappropriate handling of aborted FTP data transfers causes issues
  for some FTP clients.
- Issue 1084 - Implement support for configuring TLSv1.3 ciphersuites.
- Issue 1086 - Update TLSRenegotiate to work properly for TLSv1.3 sessions.
- Issue 1079 - prxs fails to detect module-specific configure/Makefile,
  leading to unexpected module load errors.
- Issue 1074 - TLS SNI connections to name-based VirtualHosts with
  TLSCertificateChainFile fail unexpectedly.
- Issue 1089 - Deprecate the MultilineRFC2228 directive.
- Issue 1067 - Generate new DH parameters for mod_tls, mod_sftp for 1.3.8.
- Issue 1101 - Update TLS minimum supported DH parameter size to 2048.
- Issue 811 - Support adding custom key/values to RedisLogOnCommand.
- Issue 1106 - TLS SNI can cause mod_quotatab to crash due to null pointer
  dereferences.
- Issue 1076 - TLS client-initiated renegotiations are supported unexpectedly.
- Issue 1105 - Improper handling of multiple IP addresses, ServerAliases in
  <VirtualHost> sections.
- Issue 1048 - Support using weak TLS certificates via the new AllowWeakSecurity
  TLSOption.
- Issue 1149 - mod_quotatab_sql failing due to SQL syntax errors.  This is a
  regression caused by Issue #392.
- Issue 1061 - Freeing uninitialized memory causes SFTP issues with ed25519
  keys.
- Issue 1111 - "Corrupted MAC on input" errors using SFTP umac-64@openssh.com
  digest.
- Issue 1171 - PassivePort randomization is broken due to SO_REUSEPORT option.
- Issue 1072 - Support configurable certificate settings in Redis SSL/TLS
  connections.
- Issue 369 - Provide function for obtaining memory pool information as e.g.
  JSON.
- Issue 1134 - AuthUserFile-based logins, directory listings are very slow due
  to unbuffered reads.
- Issue 1193 - Improper checking for reused TLS session for data transfers
  using OpenSSL 1.1.1.
- Issue 1168 - Improve error handling of OpenSSH host keys converted to PEM
  format.
- Issue 1179 - TLSRSACertificateKeyFile sanity checks fail unexpectedly for
  passphrase-protected keys.
- Issue 1174 - ftptop segfaults when using libncursesw on Gentoo.
- Issue 1204 - Once TLSTimeoutHandshake is reached, internal "timed out" flag
  never reset.
- Issue 1133 - Support include files in mod_wrap2 allow/deny tables.
- Issue 1200 - Disconnect SFTP clients that request unsupportable protocol
  versions.
- Issue 1207 - On Gentoo, "./configure --disable-ncurses" fails to link ftptop,
  due to "undefined reference to symbol 'stdscr'" error.
- Issue 1212 - mod_sql_mysql needs to quote table names due to reserved MySQL
  keywords.
- Issue 1175 - Unable to set per-user TLSOptions using mod_ifsession.
- Issue 754 - Some mod_snmp counters were not being incremented properly.
- Issue 548 - `make install` target should install only, not recompile any code.
- Bug 4428 - <VirtualHost> name resolution does not include all associated
  IPv6 records.
- Issue 1230 - Stack overflow due to unlimited recursion possible when parsing
  JSON text.
- Issue 1232 - Unable to use %{env:FTPS} in a SQLNamedQuery.  The fix is to now
  use %{note:FTPS} instead.
- Issue 1170 - Implement support for user/host combination bans in mod_ban.
- Issue 1246 - mod_sftp_sql crashes (sigsegv) on NULL key.
- Issue 1237 - ftpasswd should default to SHA256, not MD5.
- Issue 490 - Support syntax checks on AuthUserFiles, AuthGroupFiles on startup.

1.3.7 - Released 20-Jul-2020
--------------------------------
- Issue 1027 - mod_ldap crashes at ldap_mod_init().
- Issue 1038 - Support the SOURCE_DATE_EPOCH environment variable, for
  reproducible builds.
- Issue 1043 - Invalid SCP command leads to null pointer dereference.

1.3.7rc4 - Released 30-May-2020
--------------------------------
- Bug 4376 - mod_sftp incorrectly handles SFTP protocol version 5/6
  disposition flag.
- Issue 908 - mod_sql_passwd fails to compile on FreeBSD due to timingsafe_bcmp
  function.
- Issue 907 - Implemented support for RSA SHA-2 publickey signatures in
  mod_sftp, per RFC 8332.
- Issue 912 - Support logging of data transfer remote ports in ExtendedLog.
- Issue 317 - Implement pread(2), pwrite(2) FSIO API.
- Issue 857 - Fixed regression in the handling of `%{env:...}` configuration
  variables when the environment variable is not present.
- Issue 940 - Second LIST of the same symlink shows different results.
- Bug 4394 - LogFormat %a gives local server IP address instead of remote
  client IP address.
- Issue 946 - Improve handling of ldaps URLs, LDAPUseTLS directive in mod_ldap.
- Issue 82 - Support configurable certificate settings in LDAP SSL/TLS
  connections.
- Issue 947 - Support use of SASL auth mechanisms for LDAPBindDN binds.
- Issue 954 - Support buggy/ill-behaved FTPS client shutdown behavior for CCC
  command.
- Issue 959 - FTPS uploads using TLSv1.3 are likely to fail unexpectedly.
- Issue 682 - IPv6 addresses not properly parsed in From directives, causing
  unexpected <IfClass> mismatches.
- Issue 964 - Unable to load mod_sftp, mod_sql_passwd as shared modules on
  Alpine.
- Issue 968 - Require TLSv1.3 data connection sessions to reuse same session as
  control connection for TLSv1.3 session tickets.
- Issue 366 - ftptop should support batch mode.  ftptop now supports -b and -n
  command-line options, like top(1).
- Issue 808 - ProFTPD should ignore supplemental groups when run as a non-root
  user.
- Issue 980 - mod_sftp sends broken response when CREATETIME attribute is
  requested.
- Bug 4390 - Implement keepalive support for mod_sql/database connections.
- Issue 693 - mod_sftp unsuccessful login count issues on AIX.
- Issue 984 - Do not send EXT_INFO messages to SSH clients which did not
  signal "ext-info-c".
- Issue 983 - Use re-entrant versions of time functions where available.
- Bug 4398 - Handle zero-length SFTP WRITE requests without error.
- Bug 4185 - Implement options for tuning fields used in syslog/module logging.
- Issue 1010 - Allow ban entries to apply to all <VirtualHost> sections.
- Issue 1018 - PidFile should not be world-writable.
- Issue 1014 - TLSv1.3 handshake fails due to missing session ticket key on
  some systems.
- Issue 1023 - Lowercased FTP commands not properly identified.

1.3.7rc3 - Released 20-Feb-2020
--------------------------------
- Issue 810 - mod_tls does not compile with LibreSSL 2.9.x.
- Issue 750 - MaxClientsPerUser not enforced for SFTP logins when mod_digest
  enabled.
- Issue 850 - mod_tls should honor SNI in TLS handshake.
- Issue 692 - Support bcrypt passwords in mod_sql_passwd.
- Issue 793 - mod_sftp does not support OpenSSH-specific private key format.
- Bug 4221 - Add support for ssh-ed25519 keys.
- Issue 863 - Directory listing is slower compared to previous ProFTPD versions.
- Issue 859 - Improper handling of TLS CRL lookups.
- Bug 4340 - "SocketOptions keepalive off" does not disable TCP keepalive on
  control connection.
- Issue 870 - Leaking PAM handler and data in case of unsuccessful
  authentication.
- Bug 4385 - SSH authentication fails for many clients due to receiving of
  SSH_MSG_IGNORE packet.
- Issue 872 - Show PathAllowFilter, PathDenyFilter failure in system logging.
  Commands denied by these Filter directives are now logged at the NOTICE
  level in the system logging.
- Bug 4382 - Incorrect %F SQLLog with SFTP, not FTP, uploads.
- Issue 882 - mod_sql "named connection already exists" error when using
  name-based virtual hosts.
- Issue 890 - SFTP publickey authentication fails unexpectedly when user has
  no shadow password info.
- Issue 898 - ftpasswd fails to restore password file permissions in some cases.
- Issue 903 - Use-after-free vulnerability in memory pools during data transfer.
- Issue 902 - Out-of-bounds read in mod_cap getstateflags() function.  This
  happens because of an out-of-date libcap version; we now rely solely on the
  system-provided libcap library.

1.3.7rc2 - Released 19-Oct-2019
--------------------------------
- Issue 846 - Remote denial-of-service due to issue in network IO handling
  (CVE-2019-18217).

1.3.7rc1 - Released 12-Oct-2019
--------------------------------
- Bug 4304 - Configure script wrongly detects AIX lastlog functions.
- Bug 3127 - ProFTPD does not build when configure is run from directory other
  than source directory.
- Bug 4279 - Disable Blowfish, RC4, RIPE-MD160 SSH2 algorithms by default.
- Bug 4306 - AllowChrootSymlinks off could cause login failures depending on
  filesystem permissions.
- Issue 269 - Disable building of mod_ident by default.
- Issue 501 - mod_ctrls: error: unable to bind to local socket: Address already
  in use.
- Issue 507 - Failed to handle multiple %{env:...} variables in single word
  in configuration.
- Issue 515 - Support %b variable for ExecEnviron directive.
- Issue 521 - Broken OCSP Stapling implementation fails to find issuing
  certificate properly.
- Issue 518 - Provide option to disable sending of fake "tryLater" OCSP
  response.
- Issue 519 - Improve handling of cached OCSP responses.
- Bug 4307 - High CPU load on CWD to non existing directory.  This has been
  addressed by improving the in-memory config tree DFS algorithm to
  short-circuit recursive searching where possible.
- Issue 505 - Support MODE Z even for FTPS sessions.
- Issue 351 - Support FTP RANG command.
- Bug 4308 - mod_sftp fails to check shadow password information when publickey
  authentication used.
- Bug 4309 - Use of "AllowEmptyPasswords off" breaks SFTP/SCP logins.
- Issue 534 - Support configuring multiple curves using TLSECDHCurve.
- Bug 4310 - Use of mod_facl as static module causes ProFTPD to die on
  SIGHUP/restart.
- Bug 4311 - Directory creation in mod_site_misc, mod_copy does not honor
  directory Umask.
- Issue 445 - Remove non-functional TransferPriority directive.
- Issue 550 - Support Redis SELECT for multiple databases.
- Issue 396 - Support for Redis Sentinel deployments in mod_redis.
- Issue 556 - Use of curve25519-sha256@libssh.org SSH2 key exchange sometimes
  fails.
- Issue 536 - Support TLSv1.3 (assuming OpenSSL support).
- Bug 4312 - Close extra file descriptors at startup.
- Bug 4314 - <Anonymous> with AuthAliasOnly in effect does not work as expected.
- Issue 568 - CreateHome NoRootPrivs only works partially.
- Bug 4313 - ExtendedLog incorrectly/unexpectedly logs unknown/unsupported
  commands.
- Issue 578 - SFTP OPEN response includes attribute flags that are not actually
  provided.
- Bug 4318 - Truncation of file while being downloaded with sendfile enabled
  causes timeouts due to infinite loop.
- Bug 4320 - Confusing mod_sftp log message "disconnected by user (Application
  error)" changed to "(Application disconnected)".
- Bug 4241 - RootRevoke should be on/true by default.
- Bug 4281 - Redesign support for Backend SQLAuthType for MySQL.  If the MySQL
  client library cannot support the SQLAuthType Backend, mod_sql_mysql will
  emit a warning on startup.
- Bug 4319 - FTP uploads frequently break due to "Interrupted system call"
  error.
- Issue 618 - Site-to-site transfers over TLS fail.
- Bug 4322 - Can't see symlinks using any FTP client when using MLSD.
- Issue 610 - Generate new DH parameters for mod_tls, mod_sftp for 1.3.7.
- Bug 4325 - mod_tls 1.3.6 fails to compile using OpenSSL 0.9.8e.
- Bug 4326 - Using MaxClientsPerHost 1 in <Anonymous> section denies logins.
- Issue 642 - SQLNamedConnectInfo with different backend database does not work
  properly.
- Issue 654 - mod_sql_sqlite should error if configured SQLite database does
  not exist.
- Issue 656 - Segfault with mod_sftp+mod_sftp_pam after successful
  authentication using keyboard-interactive method
- Issue 660 - autoconf always fails to detect support for FIPS.
- Issue 663 - SFTP connections fail when using "arcfour256" cipher.
- Bug 4335 - mod_auth_otp fails to build with OpenSSL 1.1.x.
- Bug 4341 - scp broken on FreeBSD 11.
- Issue 676 - SQLLog for SCP: %{file-size} is not available.
- Issue 674 - Update mod_sftp to handle changed APIs in OpenSSL 1.1.x releases.
- Bug 4356 - Infinite loop possible in mod_sftp's set_sftphostkey() function.
- Bug 4352 - Some ASCII text files corrupted when downloading.
- Issue 797 - Properly use the --includedir, --libdir configure variables in
  the generated proftpd.pc pkgconfig file.
- Bug 4350 - Reading invalid SSH key from database results in
  unexpected/unlogged disconnect failures.
- Bug 4332 - Symlink navigation broken after 1.3.6 update.  The changes for
  Bug#4219 have been rolled back.
- Issue 795 - Unable to connect to ProFTPD using TLSSessionTickets and TLSv1.3.
- Bug 4372 - SITE CPFR/CPTO do not honor <Limit> configurations.
- Issue 807 - Using "TLSProtocol SSLv23" does not enable all protocol versions.

1.3.6 - Released 09-Apr-2017
--------------------------------
- Bug 4284 - SITE UTIME not working with group permissions.
- Bug 4289 - LDAPSearchScope does not alter search scope as expected.  When
  the LDAPServer directive is used with LDAP URLs, the LDAPSearchScope should
  not be used; the handler was failing to handle this case properly.
- Bug 4285 - In AIX, log failed logins so that user accounts can be locked by
  the OS after multiple failed login attempts.
- Added mod_wrap2_redis to the contrib/ modules directory.
- Bug 4295 - AllowChrootSymlinks off does not check entire DefaultRoot path
  for symlinks (CVE-2017-7418).
- Bug 4299 - TimeoutLogin not working for SFTP connections.

1.3.6rc4 - Released 15-Jan-2017
--------------------------------
- Bug 4283 - All FTP logins treated as anonymous logins again.  This is a
  regression of Bug#3307.

1.3.6rc3 - Released 14-Jan-2017
--------------------------------
- Bug 4222 - Add support for curve25519-sha256@libssh.org key exchange.
- Bug 4186 - ProFTPD creates name-based vhost when it should not.
- Bug 4233 - Support enforcing minimum key lengths for SFTP/SCP.
- Bug 4235 - Recursive SCP uploads of directories fail with "No such file or
  directory".
- Bug 4154 - Support for scrypt in mod_sql_passwd.  This also includes
  support for Argon2, assuming use of libsodium-1.0.9 or later.
- Bug 4237 - Corrupted ASCII uploads.  The refactoring work for Bug#4151 had
  introduced a bug in the handling of ASCII uploads, now fixed.
- Bug 4220 - Support reading geoip filters from SQL databases.
- Bug 4242 - Using mod_memcache results in segfault (signal 11).  Caused by
  a bug in libmemcached-1.0.18 and earlier.
- Bug 4244 - Long-running sessions consume memory continuously.
- Bug 4248 - ALLO command failed unexpectedly.
- Bug 4247 - ProFTPD runs out of memory when listing very large directories
  (e.g. over 400GB).
- Bug 4254 - SSH rekey during authentication can cause issues with clients.
- Bug 4257 - Recursive SCP uploads of multiple directories not handled properly.
- Bug 4252 - Clients sometimes receive extra 450 response on ABOR.
- Bug 4259 - LIST returns different results for file, depending on path syntax.
- Bug 4255 - "AuthAliasOnly on" in server config breaks anonymous logins. 
- Bug 4240 - Support OpenSSL 1.1.x API.
- Bug 4262 - SITE CPTO returns 250 even when the copy operation fails due to
  the user's quota being exceeded.
- Bug 4263 - SITE CPTO terminated by TimeoutIdle.
- Bug 4265 - Omit version information from ServerIdent banner by default.
- Bug 4264 - Support larger fixed DH groups in SSH key exchange.
- Bug 3849 - Allow wildcarded directory names in Include patterns.
- Bug 3662 - Allow SIZE command while in ASCII mode via build-time option.
- Bug 4272 - CapabilitiesEngine directive not honored for <IfUser>/<IfGroup>
  sections.
- Bug 4267 - NLST should allow for sorted output.  The ListOptions directive
  now supports a SortedNLST flag for such use cases.
- Bug 4260 - Restarting server fails when using password-protected SSL
  certificates and no TLSPassPhraseProvider.
- Bug 4216 - SSH rekeying causes invalid packet due to interrupting timer.
- Bug 4278 - Memory leak when mod_facl is used.

1.3.6rc2 - Released 10-Mar-2016
--------------------------------
- Bug 4187 - mod_geoip does not load all of the GeoIPTables properly.
- Bug 4167 - CR/LF characters are not supported in filenames.
- Bug 4188 - Support filtering based on country code and regional code in
  mod_geoip.
- Bug 4151 - FTP ASCII mode conversion algorithm is painfully slow.
- Bug 4139 - Support rejecting empty passwords.  See new AllowEmptyPasswords
  directive.
- Bug 4189 - Support protocol exclusion via TLSProtocol directive.
- Bug 4153 - Support requiring multiple SSH authentication methods.
- Bug 4191 - "Incorrect string value" reported by mod_sql_mysql for some UTF8
  characters.
- Bug 4097 - SSH rekey fails when using RSA hostkey smaller than 2048 bits.
- Bug 4198 - MLSD/MLST fact type "cdir" is incorrectly used for the current
  working directory.
- Bug 4201 - HiddenStores temporary files not removed when exceeding quota
  using SCP.
- Bug 4202 - MLSD lines not properly terminated with CRLF.
- Bug 4209 - Zero-length memory allocation possible, with undefined results.
- Bug 4210 - Avoid unbounded SFTP extended attribute key/values.
- Bug 4104 - Handle MasqueradeAddress resolution errors due to startup
  sequencing.
- Bug 4056 - Support using JSON when storing ban information in memcached.
- Bug 4057 - Support using JSON when storing TLS session information in
  memcached.
- Bug 4212 - Ensure that FTP data transfer commands fail appropriately when
  "RootRevoke on" is in effect.
- Bug 4175 - Support for OCSP stapling.
- Bug 4176 - Support for TLS session tickets.
- Bug 4200 - Support TLS client configuration for SQL servers.
- Bug 4213 - Deprecate the NoCertRequest TLSOption.
- Bug 4214 - Allow UseEncoding to be set on a per-user basis.
- Bug 4217 - Handle FTP re-authentication attempts better.
- Bug 4218 - Support a LogFormat variable for logging command duration in
  milliseconds.
- Bug 4223 - Permissions on files uploaded via STOU do not honor configured
  Umask.
- Bug 4219 - Better handling of symlinks when chrooted.
- Bug 4224 - Prohibit FTP indexing by web crawlers via auto-generated
  robots.txt.
- Added mod_auth_otp, mod_digest, mod_statcache to the contrib/ modules
  directory.
- Bug 4227 - Support SFTP clients that send multiple INIT requests.
- Bug 4230 - TLSDHParamFile directive appears ignored because unexpected DH is
  chosen.

1.3.6rc1 - Released 27-May-2015
--------------------------------
- Bug 4055 - "error setting listen fd IPV6_TCLASS: Protocol not available" log
  message.
- Bug 3944 - Session closed if active data transfer fails due to "Address
  already in use" error.
- Bug 3983 - Change default SyslogLevel to be NOTICE rather than DEBUG.
- Bug 3990 - Use 213 response code for STAT on a file.  STAT on a directory
  now results in a 212 response code as well, per RFC 959.
- Bug 4061 - SNMPAgent should support multiple addresses, including IPv6
  addresses.
- Bug 4062 - Support PID variable in HiddenStores filename.
- Bug 4065 - mod_sftp should provide the SSH client banner as environment
  variable, for logging.
- Bug 4067 - Create ExtendedLog class for SFTP requests.
- Bug 4068 - MaxClients directive doesn't work for <Anonymous> sessions.
- Bug 4069 - NLST -a shows / directory instead of the current directory.
- Bug 4063 - Unable to create directory on NFS/CIFS partition: Permission
  denied.
- Bug 4073 - Polycom VOIP phones unable to use FTPS data transfers.
- Bug 4070 - Support wider range of causes of authentication failure.
- Bug 4077 - ShaperLog not closed/reopened on SIGHUP, causing log rotation
  problems.
- Bug 4076 - Ability to disable mod_exec on a per-directory basis.
- Bug 4079 - Invalid response encoding for SFTP space-available request.
- Bug 4080 - mod_sftp does not implement SFTP LINK request properly.
- Bug 4083 - Using SQLDefaultHomedir with null home results in "No such user".
- Bug 4084 - "NLST *" returns files from subdirectories.
- Bug 4081 - Not possible to create relative symlinks with SFTP.
- Bug 4087 - mod_sftp does not handle "MaxLoginAttempts none" properly.
- Bug 4089 - mod_sftp does not allow multiple attempts using a given
  authentication method.
- Bug 4090 - mod_wrap2_file does not support IPv6 addresses properly.
- Bug 4091 - Log "Operation not permitted" privs errors at NOTICE rather than
  ERROR.
- Bug 4093 - Improve mod_sftp handling of missing packet payloads.
- Bug 4050 - Use of PIPE_BUF causes build failure on platforms without it.
- Bug 4020 - Add minimum delay options to mod_delay functionality.
- Bug 4030 - Cache negative/failed Auth API name/ID lookups.
- Bug 4094 - Available space on file system using %f displays wrong value.
- Bug 4012 - Failure to build mod_tls when using static libcrypto due to libdl
  linker errors.
- Bug 4098 - mod_sftp unable to use SFTPHostKey due to being group readable in
  CentOS 7.
- Bug 4108 - SSL handshakes for data connections sometimes stall for 3-30
  seconds.
- Bug 4109 - setsockopt() call for IPV6_TCLASS should use IPPROTO_IPV6.
- Bug 4110 - proftpd on Solaris should use /dev/conslog instead of /dev/log.
- Bug 4114 - mod_tls should not support SSLv3 by default.
- Bug 4112 - Failure to connect using mod_sftp sometimes due to too-small
  buffers.
- Bug 4035 - HiddenStores file not renamed every time.
- Bug 4116 - Report exact SSL/TLS protocol version used in client connections.
- Bug 4124 - DeleteAbortedStores defaults to "on" for all transfers, not just
  HiddenStores.
- Bug 4129 - mod_sql caches incorrect UID/GID when name cannot be retrieved.
- Bug 4130 - Support the 3-timestamp form of SITE UTIME.
- Bug 4131 - mod_sftp's autoconf script does not detect OpenSSL SHA2 support.
- Bug 4058 - Create a 'timing' trace channel, for timing-related data.
- Bug 4125 - mod_lang should provide way to reject illegally-encoded filenames.
- Bug 4060 - Support unsorted LIST entries (-U) to decrease memory/CPU usage
  for large directory listings.
- Bug 4133 - LDAPUsers directive does not honor uid-number-filter-template
  parameter.
- Bug 4137 - GeoIPDenyFilter incorrectly takes precedence over GeoIPAllowFilter.
- Bug 4138 - Support for hex-encoded salts in mod_sql_passwd.
- Bug 4140 - SFTP READLINK requests to symlinks to directories fail.
- Bug 4143 - HTTPS/FTPS protocol confusion leads to XSS.
- Bug 4144 - Support APPE when HiddenStores are enabled.
- Bug 4031 - Support JSON output format for ftpwho.
- Bug 4145 - Segfault if AuthUserFile is a relative symlink.
- Bug 4152 - Reduce logging of non-fatal "unable to open incoming connection"
  errors.
- Bug 4155 - SSH keys with too-long Comment headers aren't recognized by
  mod_sftp_sql.
- Bug 4159 - Support ability to disable ASCII translation transparently to FTP
  clients.
- Bug 4156 - Segfault handling LIST/NLST FTP command on Mac OS X.
- Bug 4160 - Malformed response to SSH_FXP_REALPATH with SFTP version 6.
- Bug 4163 - Remove support for EXPORT grade ciphers.
- Bug 4164 - mod_sql fails to read UID/GID values larger than 32 bits from SQL
  tables.
- Bug 4157 - LIST/NLST of 1000s of files is slow on some platforms.
- Bug 4059 - Implement additional RADIUS attributes.
- Bug 4166 - mod_sftp sessions consume large amounts of memory due to rekeying.
- Bug 4169 - Unauthenticated copying of files via SITE CPFR/CPTO allowed by
  mod_copy.
- Bug 4170 - Incorrect handling of control-byte field of SSH_FXP_REALPATH as
  bitmask rather than enumeration for SFTP protocol version 6.
- Bug 4168 - Race condition with HiddenStores and TimeoutIdle timeout, causing
  hidden file not to be cleaned up properly.
- Bug 3125 - Support for Mac OS X implementation of POSIX ACLs.
- Bug 4174 - Support for TLS-PSK (pre-shared keys).
- Bug 4178 - TLS session reuse requirement for data connections not properly
  enforced.
- Bug 4184 - Remove support for "weak" Diffie-Hellman groups.
- Bug 3289 - Support the HOST command.

1.3.5 - Released 15-May-2014
--------------------------------
- Bug 4018 - Implement checks for sensitive directories when chrooted.
- Bug 4022 - "Directory not empty" error when creating directory is misleading.
- Bug 4025 - <IfClass> sections do not work for multiple SQLLog directives.
- Bug 4029 - TLSOptions EnableDiags logs "unknown version (771)" for
  TLS 1.1/1.2 connections.
- Bug 3938 - mod_wrap2 uses reverse DNS regardless "UseReverseDNS off".
- Bug 4032 - Restarting proftpd with mod_sftp fails due to permissions on
  SFTPHostKey file.
- Bug 4033 - mod_sftp fails to create SSH2 session using 'none' cipher.
- Bug 4034 - SSH publickey authentication fails with "MaxLoginAttempts 1".
- Bug 4024 - TLS 1.1/1.2 configurable, but not properly implemented.
- Bug 4046 - ALLO command failed because of bad size check.
- Bug 4048 - Race condition in mod_ban can lead to segfault of all new
  connections.
- Bug 4049 - mod_exec should include supplemental groups when running commands
  as logged-in user.
- Bug 4042 - MIC command between RNFR and RNTO should not be rejected.
- Bug 4044 - mod_facl prevents a normal SIGHUP reload.
- Bug 4052 - Enhance SQLPasswordPBKDF2 to support per-user query for settings.

1.3.5rc4 - Released 28-Jan-2014
--------------------------------
- Bug 3945 - Spurious log messages at session close.
- Bug 3946 - Null pointer dereference causes segfault when logging
  %{transfer-status}, %{transfer-failure} LogFormat variables on EXIT.
- Bug 3947 - LogFormat %f variable not resolved properly for SFTP renames.
- Bug 3950 - LogFormat %d/%D variables not resolved properly for directory
  listings.
- Bug 3949 - RNFR/RNTO not logged as expected for SFTP EXTENDED
  posix-rename@openssh.com requests.
- Bug 3948 - Support FTP response codes in ExtendedLog for SFTP data transfers.
- Bug 3858 - mod_delay allows too-large values, leading to client hang on
  authentication.
- Bug 3951 - Null pointer dereference for mod_ldap logins when
  LDAPDefaultAuthScheme not configured.
- Bug 3954 - scp downloads result in segfault.
- Bug 3957 - ProFTPD configuration with thousands of <Directory>/<Limit>
  sections leads to slow logins.
- Bug 3959 - mod_sftp does not honor <Directory>/<Limit> sections when symlinks
  are involved.
- Bug 3958 - Directory creation does not honor single-parameter Umask setting.
- Bug 3960 - Support the CAP_FSETID Linux capability, for preserving directory
  SGID bit.
- Bug 3962 - Directory creation fails (chmod(2) EPERM) when root privs are used
  in some cases.
- Bug 3955 - Support secure FXP (site-to-site) transfers using SSCN.
- Bug 3966 - LogFormat %f variable not resolved for some commands.
- Bug 3971 - Support SQLOption for ignoring client library config files when
  needed.
- Bug 3972 - Authentication error on Cygwin due to bad code.
- Bug 3973 - mod_sftp can be forced to allocate too much memory for
  keyboard-interactive authentication.
- Bug 3974 - PathDenyFilter directive does not work as expected for SFTP
  sessions.
- Bug 3963 - Improve permission setting when creating directories.
- Bug 3975 - Error printed to stderr when loading GeoIP Lite country database
  using IndexCache flag.
- Bug 3976 - ProFTPD terminating (signal 11) crash for GeoLiteCity-20130903
  database lookup.
- Bug 3964 - Support running ExecOnEvent actions with logged-in user's
  permissions.
- Bug 3979 - mod_sql_odbc compiler warnings on 64-bit systems using unixODBC.
- Bug 3952 - Make PersistentPasswd default to 'off'.
- Bug 3981 - Null pointer dereference in mod_exec with ExecOption useStdin.
- Bug 3982 - Normalize log messages and levels.
- Bug 3888 - Add LDAPLog directive to mod_ldap.
- Bug 3986 - Support filesystems which do not support chmod(2)/chown(2),
  e.g. FAT/ExFAT.
- Bug 3991 - SSL session caching modules use incorrect OpenSSL cache mode flags,
  breaking session caching.
- Bug 3987 - LogFormat variable for just the filename.
- Bug 3965 - Timeout directives have inconsistent maximum values.
- Bug 3998 - Support IgnoreSCPUploadTimes SFTPOption.
- Bug 3995 - ftpasswd utility should prevent concurrent modification of files.
- Bug 3994 - ftpasswd utility should support --lock/--unlock options.
- Bug 3970 - ProFTPD should not use fd 2 (stderr) for files. 
- Bug 3772 - Support Elliptic Curve Cryptography (ECC) certs for
  FTPS connections.
- Bug 3992 - RSA signature issue when connecting using PuTTY/WinSCP.
- Bug 3996 - Handling ALLO command can result in wrong response when chrooted.
- Bug 3876 - ExecOnEvent should be configurable per <VirtualHost>/<Global>.
- Bug 4001 - mod_sftp fails key exchange for 8192-bit DH group.
- Bug 4002 - Add 7680-bit DH parameter to mod_sftp bundled dhparams.pem file.
  A 3072-bit DH group was also added.
- Bug 4004 - IgnoreSCPUploadPerms SFTPOption not honored properly for SCP
  directory upload.
- Bug 4006 - RADIUS "service-type" attribute encoded with wrong length on
  64-bit system.
- Bug 4011 - NLST ../ shows current directory contents rather than parent
  directory.
- Bug 4013 - SCP upload of shorter file does not completely overwrite existing
  file of same name.
- Bug 4014 - CommandBufferSize should override PR_DEFAULT_CMD_BUFSZ.

1.3.5rc3 - Released 14-Jun-2013
--------------------------------
- Bug 3910 - Clang's scan-build warns on set[u][g]id unchecked return value.
- Bug 3914 - 1.3.5rc2 fails to build on Solaris 10.
- Bug 3917 - Make DeleteAbortedStores on by default when HiddenStores enabled.
- Bug 3918 - mod_sftp segfault after SIGHUP when evaluating client banner.
- Bug 3864 - Support SQL query to lookup/use primary key for logged-in
  user/group.
- Bug 3920 - Support umac-64@openssh.com digest for mod_sftp.
- Bug 3921 - Single failed keyboard-interactive login attempt causes SSH
  connection to close prematurely.
- Bug 3923 - mod_cap does not revoke root privileges properly for SFTP
  connections.
- Bug 3926 - Support OpenSSH fsync SFTP extension.
- Bug 3925 - SFTP directory listings are sensitive to locale environment
  variables.
- Bug 3924 - HideFiles does not filter symlinks.
- Bug 3929 - pam_session_close() requires root privs on some platforms.
- Bug 3932 - SQLAuthType Backend returns "password mismatch" for MySQL
  PASSWORD().
- Bug 3934 - HideUser/HideGroup do not work as expected for virtual users.
- Bug 3935 - scp download of nonexistent file results in client hang.
- Bug 3927 - Default ControlsSocket created despite custom ControlsSocket path.
- Bug 3937 - Segfault when retrieving SSH public key from LDAP directory.
- Added new mod_snmp contrib module.
- Bug 3939 - Disable Controls for "ServerType inetd" servers.
- Bug 3942 - mod_sftp_sql should support multiple keys concatenated together
  in a single column.
- Bug 3943 - Support for PBKDF2 passwords in mod_sql_passwd.
- Bug 3941 - RLimitProcesses causes problems with setuid/setreuid.

1.3.5rc2 - Released 06-Mar-2013
--------------------------------
- Bug 3859 - MLSD fails to show symlinks when ShowSymlinks is not configured.
- Bug 3860 - Add a default deny option for mod_geoip.
- Bug 3862 - Support for FTPS-specific MasqueradeAddress functionality.  A
  new TLSMasqueradeAddress directive has been added to mod_tls.
- Bug 3863 - mod_sftp does not handle MaxLoginAttempts properly.
- Bug 3865 - BanEngine not set in "server config" results in "mod_ban not
  enabled" ftpdctl error.
- Bug 3866 - Issuing invalid 'ftpdctl ban' request causes segfault.
- Bug 3867 - ftpasswd fails with "Permission denied" when adding subsequent
  passwd/group entries.
- Bug 3868 - Only first DH param in TLSDHParamFile is used, regardless of
  requested keylength.
- Bug 3870 - Handling of OPTS command can lead to crash.
- Bug 3779 - Generate new DH parameters for mod_tls and mod_sftp.
- Bug 3871 - REALPATH SFTP request not properly handled by <Limit DIRS>
  configuration.
- Bug 3872 - Use HiddenStores directive to customise suffix.
- Bug 3873 - Provide FTP response code in ExtendedLog for failed SFTP REMOVE
  request.
- Bug 3869 - Use longer SSL session cache expiration by default.
- Bug 3874 - Use of O_EXCL flag on HiddenStores files might break for NFS
  filesystems.
- Bug 3878 - QuotaExcludeFilter not honored for uploads when 'hard' limits are
  used.
- Bug 3879 - Allow additional columns in SQLNamedQuery queries used for quota
  limits and tallies.
- Bug 3882 - DisplayLogin with an absolute path does not work properly within
  an <IfGroup> section.
- Added new mod_log_forensic contrib module.
- Bug 3881 - <Directory> sections within <IfGroup> sections not applied as
  expected.
- Bug 3884 - Configure script not detecting MySQL make_scrambled_password
  functions.
- Bug 3887 - <Limit ALL> erroneously blocks the PROT command used for FTPS.
- Bug 3819 - Second and subsequent LIST of directory with many files is very
  slow.
- Bug 3889 - Support millisecond timestamp LogFormat variable.
- Bug 3891 - Allow TLSProtocol directive in <VirtualHost> and <Global> sections.
- Bug 3753 - Support SFTP request names in <Limit> sections better.
- Bug 3892 - mod_auth_file should have strict permission checks of configured
  files.
- Bug 3893 - Add SQLLogOnEvent directive, for performing SQL query on
  configurable event.
- Bug 3894 - ftptop doesn't work with --enable-nls.
- Bug 3895 - Missing TransferLog entry under some out-of-space conditions.
- Bug 3897 - mod_sftp does not handle a REALPATH request properly for SFTP
  protocol version 6.
- Bug 3896 - Warn when world-writable config files are used.
- Bug 3899 - Support authentication of users based on SSL/TLS client
  certificate.
- Bug 3903 - With mod_log_forensic enabled, SSH connections fail randomly.
- Bug 3905 - Handle the Linux-specific PAM_RADIO_TYPE message properly.
- Bug 3709 - Support download-triggered emails in the ftpmail script.
- Bug 3904 - scp downloads using glob pattern sometimes fails.
- Bug 3900 - ProFTPD terminating (signal 11) on some sftp connections.
- Bug 3906 - Support ban rule for clients which perform SSL/TLS handshakes too
  frequently.

1.3.5rc1 - Released 04-Jan-2013
--------------------------------
- Bug 3712 - mod_wrap2/mod_load build errors: missing config.h.
- Bug 3713 - mod_tls cannot be compiled using Openssl 0.9.6.
- Bug 3646 - Debug logging to stderr should include timestamps and PID.
- Bug 3714 - ftpwho/ftptop are not showing command arguments (e.g. downloaded
  file name).
- Bug 3715 - MLSD/MLST fail when "DirFakeUser off" or "DirFakeGroup off" used.
- Bug 3717 - proftpd fails to run with "Abort trap" error message.
- Bug 3719 - LIST -R can loop endlessly if bad directory symlink exists.
- Bug 3720 - Various module logfile permissions are 0600 instead of 0640.
- Bug 3723 - mod_memcache segfault on server restart.
- Bug 3721 - mod_rewrite does not replace characters if there are more than
  8 occurrences.  To handle this situation, a new RewriteMaxReplace directive
  has been added for configuring this limit.
- Bug 3724 - Unloading mod_quotatab causes segfault.
- Bug 3686 - Support SHA2 digests in mod_sftp.  See the SFTPDigests directive
  documentation for more information.
- Bug 3629 - Support <IfAuthenticated> conditional config section.
- Bug 3682 - Configure does not detect libiconv under Gentoo FreeBSD.
- Bug 3726 - mod_exec does not always capture stdout/stderr output from
  executed command.
- Bug 3727 - mod_wrap2 causes unexpected LogFormat %u expansion for SFTP
  connections.
- Bug 3729 - mod_ldap can segfault when LDAPUsers is used with no optional
  filters.
- Bug 3728 - Build failure in wtmp.c on Gentoo/FreeBSD on sparc.
- Bug 3734 - DirFakeUser/DirFakeGroup off with name causes SIGSEGV for
  MLSD/MLST commands.
- Bug 3739 - Allow for configurable SSH version identifiers in mod_sftp.  The
  SSH version identifier can now be configured for mod_sftp via the
  ServerIdent directive.
- Bug 3718 - ftptop fails to build on OpenSUSE.
- Bug 3699 - ProFTPD crash on start up on Mac OSX Lion with NLS enabled.
- Bug 3744 - Support ls(1) -1 option for LIST command.
- Bug 3746 - Support applying ListOptions only to NLST or to LIST commands.
- Bug 3747 - Support option for displaying symlinks via MLSD using syntax
  preferred by FileZilla.  The new FactsOptions directive can be used for
  this purpose.
- Bug 3745 - Reject PASV command if no IPv4 address available.
- Bug 3701 - Modify ScoreboardFile directive to support disabling scoreboarding.
- Bug 3742 - Improper handling of self-signed certificate in client-sent cert
  list when "TLSVerifyClient on" is used.
- Bug 3749 - Compile of src/netacl.c fails on Tru64 UNIX (OSF/1) due to
  conflict with system header.
- Bug 3743 - Random stalls/segfaults seen when transferring large files
  via SFTP.
- Bug 3752 - proftpd process exit status is zero for "Failed binding to
  address, port N: Address already in use" startup failure.
- Bug 3751 - mod_ban does not close/reopen the BanLog/BanTable file descriptors
  on restart, causing a file descriptor leak.
- Bug 3707 - Add request/transfer ID to the logging of the initial and closing
  commands for SFTP file transfers.  This can now be accomplished using a
  LogFormat variable of '%{note:sftp.file-handle}'.
- Bug 3757 - Support SFTPOption for ignoring requests to modify file ownership.
- Bug 3756 - mod_ctrls no longer listens on ControlsSocket after restart.
- Bug 3731 - Support active data transfers while RootRevoke is in effect.
- Bug 3737 - Allow UTF8 when UseEncoding is used.
- Bug 3573 - Support Elliptic Curve Cryptography (ECC) in SSH.
- Bug 3758 - ProFTPD crashes when handling mod_gss authentication due to null
  pointer.
- Ability to load SSH host keys from an SSH agent, in addition to files on
  disk.  See doc/contrib/mod_sftp.html#SFTPHostKey for more information.
- Bug 3761 - SSH2 key exchange fails if client sends certain SSH message before
  NEWKEYS.
- Bug 3763 - Ensure that mod_sftp operates properly when OpenSSL FIPS mode is
  enabled.
- Bug 3764 - mod_sftp does not correctly handle a 'guess' KEX message when the
  client guesses correctly.
- Bug 3765 - mod_sftp should honor the GroupOwner directive for MKDIR requests.
- Bug 3626 - Display variable %f off by a factor of 1024 on 64-bit platforms.
- Bug 3673 - Support date/timestamp variables in mod_rewrite.
- Bug 3754 - ProFTPD refuses to delete/rename a symlink pointing outside a
  writable directory.
- Bug 3766 - Support a QuotaDefault directive, for configuring default limits.
- Bug 3767 - mod_rewrite segfault when handling SITE CHGRP without a parameter.
- Bug 3768 - ExecTimeout 0 (zero) not treated as infinite.
- Added new mod_geoip contrib module.
- Bug 3769 - Ensure that encoded strings are NUL-terminated.
- Bug 3732 - AIX build error: undefined symbol: .alloca.
- Bug 3782 - SQLShowInfo does not work properly for error responses.
- Bug 3780 - AIX gives "error setting listen fd IP_TOS: Invalid argument".
- Bug 3736 - Trying to re-authenticate an existing FTP connection causes invalid
  503 response.
- Bug 3785 - Support resolution of tilde (~) within a chrooted session.
- Bug 3787 - Read-only SFTP OPEN request permissions not properly ignored.
- Bug 3740 - Overwrite permission denied when reloading multiple times and
  multiple <VirtualHost> sections in proftpd.conf.
- Bug 3791 - Invalid handling of SCP control messages fragmented over multiple
  SSH packets.
- Bug 3794 - Cygwin build failure in lib/tpl.c due to wrong include of mman.h.
- Bug 3795 - ProFTPD needs to use -pthread linker option if linking against
  OpenSSL with thread support.
- Bug 3790 - Logfile timestamps change to GMT after MFMT command.
- Bug 3798 - Downloading nonexistent file via SCP results in timeout rather
  than error.
- Bug 3800 - Multiple *Options directives should be handled properly.
- Bug 3801 - mod_tls should have directive like Apache mod_ssl's
  SSLHonorCipherOrder.  The mod_tls module now supports a
  TLSServerCipherPreference directive.
- Bug 3804 - ioctl(RPROTDIS) code no longer needed on Solaris 11.
- Bug 3808 - Segfault in mod_tls when mod_tls_shmcache used.
- Bug 3809 - Segfaults in mod_radius when configured with RadiusGroupInfo.
- Bug 3811 - ExtendedLog entries not written if MaxClients limit reached.
- Bug 3814 - Support "configtest" command for contrib init.d script.
- Bug 3816 - Installation of ftpasswd does not honor DESTDIR environment
  variable.
- Bug 3813 - Ability to use CreateHome to create parent directories as
  non-root user, for better interoperability with NFS.
- Bug 3806 - Support reverse DNS resolution for IPv6 addresses when
  gethostbyname2(3) is not available.
- Bug 3820 - Support device/interface names in <VirtualHost>, MasqueradeAddress,
  and DefaultAddress.
- Bug 3822 - Resolving %U/%u LogFormat variables inconsistent between
  mod_log/mod_sql in certain cases.
- Bug 3824 - Use RFC compliant address/port for data transfer if FTP client has
  not sent PORT/PASV/EPRT/EPSV commands.
- Bug 3825 - Handle RFC 1918 IP addresses in PORT/EPRT commands.
- Bug 3827 - Use non-filesystem based SFTP handle generator instead of
  mktemp(3).
- Bug 3828 - Certain sequences of FTP data transfer commands lead to NULL
  pointer dereferences in mod_deflate.
- Bug 3830 - MFF/MFMT command segfaults due to insufficient parameter checks.
- Bug 3829 - RNFR without following RNTO can lead to NULL pointer dereference.
- Bug 3832 - Support disabling of system logging on per-connection basis.
- Bug 3792 - Recursive SCP uploads using preserve-time (-p) option may not work.
- Bug 3831 - Sporadic "451 Insufficient memory or file locked" failure when
  downloading.
- Bug 3833 - Enable TCP keepalive by default, with configurable SocketOption.
- Bug 3837 - mod_tls unable to read certificate files after SIGHUP.
- Bug 3842 - Incorrect handling of REALPATH requests for symlink paths in
  mod_sftp.
- Bug 3843 - ProFTPD should not fail when starting up due to loading same
  module multiple times.
- Bug 3845 - mod_sftp does not provide response codes for %s LogFormat variable
  for AUTH ExtendedLog.
- Bug 3846 - Avoid scanning ScoreboardFile needlessly on login if limits are
  not configured.
- Bug 3850 - ftpasswd should support generating SHA-256, SHA-512 hashes where
  possible.
- Bug 3851 - SFTPPassPhraseProvider fails due to incorrect pointer.
- Bug 3852 - Support directive for ignoring symlink DefaultRoot directories.
  See the new AllowChrootSymlinks directive.
- Bug 3839 - Enhance mod_cap to support dropping root privs entirely.
- Bug 3841 - Possible symlink race when applying UserOwner to newly created
  directory.
- Bug 3855 - Restarting proftpd may cause Include files not to be parsed.

1.3.4 - Released 09-Nov-2011
--------------------------------
- Bug 3702 - ProFTPD with mod_sql_mysql dies of "Alarm clock" on FreeBSD.
- Bug 3669 - mod_sql_mysql.so: undefined symbol: make_scrambled_password with
  MySQL 5.5 on Fedora.
- Bug 3192 - PQescapeStringConn() needs a better check.
- Bug 3704 - Enable OpenSSL countermeasure against SSLv3/TLSv1 BEAST attacks.
  To disable this countermeasure, which may cause interoperability issues
  with some clients, use the NoEmptyFragments TLSOption.
- Bug 3706 - Support SFTPOption for ignoring requests to modify timestamps.
- Bug 3640 - rpmbuild on CentOS5.5 (64bit): "File not found by glob". 
- Bug 3711 - Response pool use-after-free memory corruption error.

1.3.4rc3 - Released 26-Sep-2011
--------------------------------
- Bug 3637 - Enforce pcre and libmemcached version requirements.
- Bug 3639 - Avoid spinning proftpd process if read(2) returns EAGAIN.
- Bug 3641 - SITE CPFR/CPTO does not update quota tally.
- Bug 3642 - Segfault seen in mod_sql_mysql if "SQLAuthenticate groupsetfast"
  used.
- Bug 3645 - Ensure that SQLNamedConnectInfos with PERSESSION connection
  policies are opened before chroot.
- Bug 3644 - Disable signal handling for exiting session processes.
- Bug 3649 - MaxStoreFileSize can be bypassed using REST/APPE.
- Bug 3652 - TCPAccessSyslogLevel directive broken by Bug#3317.
- Bug 3653 - Segfault with "DefaultServer off" and no matching server for
  incoming IP address.
- Bug 3656 - Prefer "File too big" error message for MaxStoreFilesize.
- Bug 3658 - TLSVerifyOrder directive is broken.
- Bug 3555 - Support optional maximum number of clients to be disconnected
  via 'ftpdctl kick'.
- Bug 3660 - SITE MKDIR/RMDIR should update quota tallies properly.
- Bug 3663 - TimeoutLogin cannot interrupt mod_delay as it should.
- Bug 3664 - mod_sftp does not update process title.
- Bug 3667 - Scoreboard scrubbing can block daemon process for long periods
  of time.
- mod_ldap configuration directives have been overhauled, hopefully
  yielding a more straightforward, easier way to configure mod_ldap.
  See the Changes section of README.LDAP for details.
- Bug 3665 - GID of new files are inherited from parent directory on FreeBSD.
  To provide the more expected behavior, where the GID of new files is that
  of the logged-in user, on FreeBSD machines, the GroupOwner directive can
  now handles a parameter value of "~" as "use GID of logged-in user".
- Bug 3668 - File descriptor leak during scoreboard scrubbing.  This leak
  was inadvertently introduced by the fix for Bug#3667.
- Bug 3670 - WrapDenyMsg not displayed when using mod_wrap2 + mod_sftp.
- Bug 3671 - TLSOption AllowClientRenegotiations to be unconditionally required
  for client-initiated renegotiations.  This undoes the functionality added
  for Bug#3585, in light of CVE-2011-1473.
- Bug 3674 - After running "proftpd -t" command, ftpdctl commands no longer
  work.
- Bug 3675 - Automatically disable sendfile support for AIX systems.
- Bug 3676 - RADIUS-based logins don't work using mod_sftp.
- Bug 3679 - Support NAS-IPv6-Address RADIUS attribute.
- Bug 3680 - SFTP MKDIR does not respect the IgnoreSFTPUploadPerms option.
- Bug 3681 - Non POSIX test constructions in autoconf script.
- Bug 3685 - NULL pointer dereference after an idle timeout.
- Bug 3692 - SQLLog IGNORE_ERRORS parameter does not work.
- Bug 3693 - Clients are disconnected if proftpd cannot listen on port for
  passive data transfer.
- Bug 3696 - ExtendedLog not getting written on timeouts.
- Bug 3697 - Filenames with embedded IAC do not get processed correctly.
- Bug 3698 - <Limit WRITE> does not prevent deletion of a file/directory via
  renaming.

1.3.4rc2 - Released 01-Apr-2011
--------------------------------
- Bug 3566 - Ability to turn verbose process titles off.
- Bug 3567 - IdentLookups do not work for IPv6 servers.
- Bug 3571 - RLimitMemory "max" soft/hard limits don't work.
- Bug 3572 - Support use of "notes" variables in SQLNamedQuery.
- Bug 3500 - Support for other combinations of hashed values in mod_sql_passwd.
- Bug 3524 - mod_quotatab_sql does not properly update the file upload count
  for a DELE.
- Bug 3575 - Process privileges may not handled properly when the
  --enable-autoshadow configure option is used.
- Bug 3577 - MFMT can fail due to utimes(2) peculiarities.
- Bug 3544 - mod_sftp closes channel too early after scp download.  This
  manifests as "lost connection" using OpenSSH's scp(1).
- Bug 3579 - mod_sftp_pam may tell client to disable echoing erroneously.
- Bug 3578 - Ability to suppress sending messages from PAM to clients.
- Bug 3580 - TLSSessionCache needs to allow configuring OpenSSL's internal
  session caching expiration, for long-lived sessions.
- Bug 3585 - Allow client-requested SSL session renegotiation when securely
  supported.
- Bug 3586 - mod_sftp behaves badly when receiving badly formed SSH messages.
- Bug 3591 - %F LogFormat variable should work for MKD/RMD commands.
- Bug 3592 - Support case-insensitivity option for
  PathAllowFilter/PathDenyFilter directives.
- Bug 3593 - Using "$shell $libtool" in prxs does not work for all shells.
- Added new mod_tls_memcache contrib module.
- Bug 3599 - Support SFTPOptions parameter for ignoring SFTP SETSTAT/FSETSTAT
  permission changes.
- Bug 3598 - HiddenStores makes the APPE command overwrite files instead of
  appending them.  APPE is now denied if HiddenStores is in effect.
- Bug 3565 - Support a MaxCommandRate, for detecting and throttling clients
  which are sending commands too quickly.
- Bug 3559 - ExtendedLog should support EXIT command, for logging when a
  session ends.
- Bug 3538 - WrapAllowMsg directive broken due to Bug#3423.
- Bug 3604 - Support DirFakeUser, DirFakeGroup and DirFakeMode for MLSD/MLST
  commands.
- Bug 3605 - DisplayReadme output should appear after DisplayLogin for the
  PASS command.
- Bug 3595 - Avoid buggy glibc regcomp(3) for regular expressions.  To do
  this, use the new --enable-pcre configure option to enable the use of the
  PCRE library for regular expression support.
- Bug 3607 - SocketOptions receive/send buffer size parameters no longer work.
- Bug 3606 - mod_wrap2 needs to support netmask rules for IPv6 addresses.
- Bug 3608 - Make mod_quotatab poll for the QuotaLock file.
- Bug 3576 - Support setting CapabilitiesSet on per-user basis via
  mod_ifsession's <IfUser> and <IfGroup>.
- Bug 3612 - APPE/STOU upload flags erroneously preserved across upload
  commands.
- Bug 3609 - Support full PCRE regular expressions if PCRE support is enabled.
- Bug 3614 - Malicious module can use sreplace() function to overflow buffer.
- Bug 3616 - Install contrib utilities as part of 'make install' target.
- Bug 3619 - Exiting sessions don't seem to die properly.
- Bug 3618 - ScoreboardFile locking should be more resilient.
- Bug 3617 - Enhance the Trace directive to support range of channel log levels.
- Bug 3620 - Need LogFormat variable for IP address of server handling session.
- Bug 3262 - Allow SQL logging to separate database/server.
- Bug 3574 - Better handling of ALLO command.
- Bug 3621 - mod_quotatab increments tallies for aborted uploads if
  DeleteAbortedStores is on.
- Bug 3622 - mod_delay sometimes logs "unable to load DelayTable into memory".
- Bug 3624 - Plaintext command injection in FTPS support.
- Bug 3625 - mod_ifsession rules using regular expressions do not work.
- Bug 3623 - Truncated client name saved in ScoreboardFile.
- Bug 3627 - %w variable populated with non-absolute path in SQLLog statement.
- Bug 3628 - Unnecessarily verbose "warning: unable to throttle bandwidth:
  Interrupted system call".
- Bug 3630 - SSH DISCONNECT messages sent by mod_sftp even for FTP connections
  in some cases.
- Bug 3632 - mod_sql should log "unrecoverable database error" at a higher
  priority.
- Bug 3631 - Support TraceOptions directive, for altering TraceLog format
  slightly.
- Bug 3633 - Using SQLOption noDisconnectOnError can cause ExtendedLog logging
  to silently fail.
- Bug 3610 - Proftpd is eating CPU when reparsing configuration file on SIGHUP.
- Bug 3634 - Incorrect generation of DSA signature for SSH sessions.

1.3.4rc1 - Released 17-Dec-2010
--------------------------------
- Bug 3399 - <Limit> statement does not restore access to MFMT commands.
- Bug 3365 - First certificate in TLSCertificateChainFile is skipped.
- Bug 3302 - MLST response should include full path name.
- Bug 3400 - Add Japanese translation.
- Bug 3401 - mod_sftp does not compile with pre-0.9.7 OpenSSL.
- Bug 3402 - mod_tls does not compile with pre-0.9.7 OpenSSL due to Bug#3349.
- Bug 3403 - File upload followed by MLSD leads to wrong file size entries in
  TransferLog.
- Bug 3339 - Support ban rule for clients which login too frequently.
- Bug 3405 - Multiple SFTPAuthorizedUserKeys stores causes segfault on 64-bit
  platforms.
- Bug 3404 - SyslogLevel not applied to SystemLog.
- Bug 3354 - Renaming a file across mount points to a full disk does not fail
  as expected.
- Bug 3353 - Support setting IPTOS/DSCP markings on data and control streams.
  There is a mod_qos module for handling this; see the RELEASE_NOTES for more
  details.
- Bug 3392 - Display <VirtualHost> information in 'ban info' ftpdctl action
  response.
- Bug 3393 - Specify the <VirtualHost> when using 'ban' or 'permit' ftpdctl
  actions.
- Bug 2196 - Handle IPv4-mapped IPv6 addresses as IPv4 addresses.
- Bug 3407 - Use glob characters as literal characters if no glob match found
  for LIST/NLST.
- Bug 2768 - Provide --with-mysql-config/--with-postgres-config build options.
- Bug 3408 - Use <termios.h> instead of <sys/termios.h> where possible.
- Bug 3374 - TLSVerifyClient and TLSOptions NoCertRequest are incompatible.
- Added mod_copy, mod_deflate, mod_ifversion to the contrib/ modules directory.
- Bug 3373 - RadiusGroupInfo should not require that both names and IDs be VSAs.
- Bug 3371 - Group limits in <LIMIT LOGIN> blocks won't work with
  RADIUS-supplied groups.
- Bug 3412 - Include files not included after restart due to permissions.
- Bug 3409 - Build failure on newer FreeBSD due to utmp/utmpx system changes.
- Bug 3318 - MLSD should indicate symlinks if ShowSymlinks is enabled.
- Bug 3411 - Support ftpdctl action to manually request a mod_dynmasq refresh.
- Bug 3417 - Unsafe use of pointer when scanning config for ScoreboardFile.
- Bug 3418 - %U sometimes showing up as "(none)" in ExtendedLog.
- Bug 3421 - RewriteHome does not work properly for SFTP connections.
- Bug 3413 - Support DirFakeUser, DirFakeGroup for SFTP connections.
- Bug 3419 - SSL_shutdown() errors with openssl-0.9.8m.
- Bug 3423 - Last line of multiline DisplayLogin file improperly handled.
- Bug 3426 - mod_sftp does not log to TransferLog by default.
- Bug 3425 - Improperly constructed destination paths for SCP uploads.
- Bug 3428 - Honor the Trace directive in mod_ifsession sections.
- Bug 3429 - mod_sftp should honor the UserOwner and GroupOwner directives.
- Bug 3427 - mod_sftp does not handle recursive SCP uploads properly.
- Bug 3432 - ExecBeforeCommand does not interpolate the %F/%f variables
  properly.
- Bug 3434 - TraceLog contains messages even with "Trace DEFAULT:0" configured.
- Bug 3433 - SFTPDisplayBanner does not handle variables in configured file.
- Bug 3435 - Encoding/decoding conversion can cause CPU spike.
- Bug 3436 - Support build-time option to disable use of nonblocking open of
  log files.  Use --disable-nonblocking-log-open to get the pre-1.3.3 behavior
  of opening log files.
- Bug 3437 - UseImplicitSSL TLSOption causes PBSZ/PROT commands to fail.
- Bug 3439 - Encoding fails if an NLS-enabled proftpd starts in a UTF8 locale.
- Bug 3438 - <Limit> configuration cannot be applied to OPTS command.
- Bug 3440 - ScanOnLogin QuotaOption not honored properly if tally record has
  to be created.
- Bug 3444 - Support SFTPOptions parameter to disable optimistic KEXINIT
  behavior.
- Bug 3445 - mod_sftp should send its NEWKEYS message first, before reading
  the client's NEWKEYS message.
- Bug 3443 - Deprecate the DisplayGoAway directive.
- Bug 3446 - .ftpaccess ignored in some cases.
- Bug 3447 - mod_sftp can become confused during large recursive SCP uploads.
- Bug 3448 - Ensure that STAT/LSTAT/FSTAT SFTP requests do not use cached/stale
  data.
- Bug 3449 - mod_sftp does not properly handle the O_TRUNC flag in a SFTP OPEN
  request.
- Bug 3450 - mod_sftp does not properly handle the O_APPEND flag in a SFTP OPEN
  request.
- Bug 3451 - WinSCP can't upload files using protocol version 5 with mod_sftp.
- Bug 3452 - mod_sftp does not advertise its supported SFTP extensions for
  protocol version 5.
- Bug 3454 - msgfmt(1) options used for generating NLS files are not compatible
  with Solaris' msgfmt.
- Bug 3457 - Support LogFormat variable for indicating whether a file is being
  modified.  A new "%{file-modified}" LogFormat variable is supported.
- Bug 3456 - Problem attempting to recursively download a directory via SCP.
- Bug 3458 - mod_sftp incorrectly performs OpenSSL cleanup.
- Bug 3459 - mod_radius segfaults during incorrect login due to stale data.
- Bug 3431 - Ensure that timezone info files are opened prior to chroot.
- Bug 3460 - REALPATH SFTP request can cause improperly cached directory
  configuration.
- Bug 3462 - ftpasswd script's --delete-user option does not work.
- Bug 3463 - ftpasswd script's --delete-group option does not work.
- Bug 3466 - mod_ifsession does not check for properly closed <IfUser> contexts.
- Bug 3465 - SIGSEGV at LIST after CCC.
- Bug 3470 - Deferred resolution <Directory> paths not handled properly by
  mod_sftp.
- Bug 3469 - ExtendedLog's %f variable not properly expanded for DELE if path
  begins with tilde ('~').
- Bug 3467 - mod_ifsession does not merge <Directory> blocks properly.
- Bug 3471 - Null values in allow/deny rules causes mod_wrap2 to segfault.
- Bug 3472 - mod_sftp publickey authentication fails for large keys.
- Bug 3424 - Bad LDAP lookup can cause mod_ldap segfault under some conditions.
- Bug 3396 - Support -c and -u LIST options.
- Bug 3395 - Provide LogFormat variable %d for non-directory commands.
- Bug 3476 - LIST/NLST of path starting with "-" fails.
- Bug 3475 - Add new 'noGetgrouplist' AuthUnixOption to work around buggy
  libc code.
- Bug 3474 - Using SQLite database and SQLLog directive can lead to problems
  under load.
- Bug 3479 - Support anonymous username variable in mod_exec.
- Bug 3480 - mod_sftp does not interoperate with old ssh.com/Tectia clients.
  A new "OldProtocolCompat" SFTPOption has been added.
- Bug 3481 - Problem with SFTP directory listings.
- Bug 3483 - NULL pointer dereference handling SITE command in mod_quotatab.
- Bug 3485 - Disabling IPv6 via -4 or --ipv4 command-line options does not work.
- Bug 3487 - Null pointer dereference with EPRT/EPSV/PASV/PORT command during
  data transfer.
- Bug 3482 - ProFTPD corrupts utmpx log files on FreeBSD 9.0/HEAD.
- Bug 3491 - Directory pattern not matching as expected.
- Bug 3492 - Null pointer dereference during data transfer due to RNFR/RNTO.
- Bug 3493 - mod_sftp should only expect Subject key header to match if
  explicitly configured.
- Bug 3494 - Null pointer dereference for IPv6-enabled proftpd when no
  DefaultServer configured.
- Bug 3496 - Sessions don't end when the control connection is closed during
  a data transfer.
- Bug 3495 - Support SMTP authentication in the ftpmail Perl script.  See
  the doc/contrib/ftpmail.html doc for more information.
- Bug 3501 - <Anonymous> logins with "AuthAliasOnly on" still handled as
  anonymous logins.
- Bug 3502 - Support environment variables better in the config file.
- Bug 3503 - Support CreateHome parameter for specifying the group ownership
  of the home directory.
- Bug 3390 - Add extra %-variable to LogFormat directive to log UID/GID of
  logged user.  Both LogFormat and SQLLog now support new %{uid} and %{gid}
  variables.
- Bug 3505 - Support for SSH2 client "alive" checks, a la OpenSSH's
  ClientAliveCount/Interval.
- Bug 3506 - Support ListOption for returning 226 response code when listing
  nonexistent file, instead of 450.
- Bug 3511 - SQLAuthType Backend not properly rejected by mod_sql_sqlite.
- Bug 3512 - Add ability to check client certificate CommonName (CN) when
  verifying SSL/TLS clients.
- Bug 3513 - EPERM error logged unnecessarily for SFTP logins on Linux.
- Bug 3514 - Test suite tmpdir improvements.
- Bug 3484 - Support range expressions for IP addresses in Allow/Deny/From
  rules.
- Bug 3516 - Support the "space-available" SFTP extension.
- Bug 3517 - mod_quotatab decrements file tally improperly for failed DELE
  commands.
- Bug 3518 - Support SiteMiscEngine directive, for disabling mod_site_misc
  functionality via proftpd.conf.
- Bug 3519 - Inappropriate directory traversal allowed by mod_site_misc.
- Bug 3520 -  MultilineRFC2228 directive should be supported in <VirtualHost>
  and <Global> sections.
- Bug 3521 - Telnet IAC processing stack overflow.
- Bug 3522 - Error when handling SSH DISCONNECT messages with no language tag.
- Bug 3525 - Default syslog logging causes logging to the wrong syslog
  facilities.
- Bug 3528 - ExtendedLog %s variable not expanded properly for successful PASS
  commands.
- Bug 3526 - CPU usage at 100% when checking HideFiles pattern.  Credit goes
  to Thomas Shinnick for providing the fix for this; it addresses a more
  general problem of high memory and CPU consumption when proftpd searches
  for .ftpaccess files.
- Bug 3529 - "LIST /*" now lists more than the expected directory.
- Bug 3310 - UseSendfile should be supported in <Directory> and .ftpaccess
  sections.
- Bug 3531 - mod_quotatab contains duplicate EDQUOT errno code.
- Bug 3530 - Conflicting interactions among HideUser, HideGroup, and
  HideNoAccess directives.
- Bug 3208 - Improve ScoreboardFile performance under load.  This adds a
  new ScoreboardMutex directive, which can be used to explicitly configure
  the file mutex used for starting/ending sessions.  By default, the
  ScoreboardMutex path will be automatically set to the same ScoreboardFile
  path, with a ".lck" suffix appended.
- Bug 3536 - mod_sql has insufficient bounds checking in sql_prepare_where()
  function.
- Bug 3547 - Multiple AllowClass directives not handled properly.
- Bug 3515 - Support DisplayLogin functionality for SFTP connections.
- Bug 3548 - Null pointer segfault in mod_sftp when handling aborted connection.
- Bug 3551 - SQLAuthType Crypt implementation needs to handle NULL return value
  from crypt(3).
- Bug 3550 - SFTP compressed uploads can cause corrupted uploaded files.
- Bug 3554 - Support Apache-style %I, %O LogFormat variables.
- Bug 3556 - Disable protocol support on per-user/group/class basis.
- Bug 3508 - mod_wrap2 should support checking of WrapTables allow/deny rules
  at connect time.
- Bug 3558 - Check all DNS names for a client against DNS names/patterns in
  access rules.
- Bug 3560 - ExtendedLog shows incorrect byte size for first file downloaded
  via SFTP in some cases.

1.3.3 - Released 24-Feb-2010
--------------------------------
- Bug 3389 - Cannot create mod_ban whitelists using <Class> and <IfClass>
  sections.
- Bug 3397 - HideFiles none does not work properly on a per-user basis.

1.3.3rc4 - Released 12-Feb-2010
--------------------------------
- Bug 3355 - mod_ban should support BanEngine in <VirtualHost> config sections.
- Bug 3358 - mod_tls doesn't compile with pre-0.9.7 openssl.
- Bug 3357 - mod_sftp fails to compile on AIX.
- Bug 3356 - Build timestamp using date(1) can fail depending on environment.
- Bug 3359 - mod_tls_shmcache segfaults during syntax check.
- Bug 3362 - Regression in handling of MaxLoginAttempts in 1.3.3rc1.
- Bug 3370 - Lack of PID protection in ScoreboardFile.
- Bug 3372 - ProFTPD crashes when retrying a failed login with mod_radius
  being used.
- Bug 3375 - Minor SIGHUP-based memory leak in mod_tls.
- Bug 3376 - Handle the full RFC4716 formatted keys in SQL values.
- Bug 3377 - mod_wrap2 attempts to resolve 'ALL' keyword as an IP address.
- Bug 3383 - ExtendedLog variables for protocol and version not handled
  properly.
- Bug 3381 - RADIUS authentication broken on 64-bit platforms.
- Bug 3380 - Support user-specific salts in encoded passwords.
- Bug 3385 - Memory leak during SCP download.
- Bug 3386 - Downloading via SCP can stall due to rekeying.
- Bug 3387 - SIGHUP will eventually cause certain modules (as DSO modules) to
  segfault.

1.3.3rc3 - Released 10-Dec-2009
--------------------------------
- Bug 3303 - FileZilla reports "Server did not properly shut down TLS
  connection" after TimeoutIdle triggered.
- Bug 3305 - Emulate Solaris 10 syslog "header" on Solaris 10 servers.
- Bug 3307 - All FTP logins treated as anonymous logins.
- Bug 3312 - Uploading via SFTP/SCP to FIFO whose reader is closed causes
  session to hang.
- Bug 3313 - Uploading via SFTP to FIFOs fails due to illegal lseek(2),
  truncate(2) calls.
- Bug 3314 - Downloading from FIFOs via SFTP/SCP fails.
- Bug 3315 - Support the %u variable in SFTPAuthorizedUserKeys paths.
- Bug 3316 - Messages from PAM modules are ignored when authenticating SSH
  clients via 'keyboard-interactive'.
- Bug 3317 - mod_wrap/libwrap should honor SyslogFacility setting.
- Bug 3311 - configure script should automatically detect when -ldl is needed
  by OpenSSL.
- Bug 3324 - Vulnerability in SSL/TLS protocol during renegotiation
  (CVE-2009-3555).
- Bug 3327 - Clear external SSL session caches on server restart/shutdown.
- Bug 3326 - Shared memory segment used for session cache should be protected
  via mlock(2).
- Bug 3322 - Support the "version-select" SFTP extension.
- Bug 3321 - Support the "check-file-name" and "check-file-handle" SFTP
  extensions.
- Bug 3320 - Support the "copy-file" SFTP extension.
- Bug 3328 - Failed database transaction can cause mod_quotatab to loop
  endlessly.
- Bug 3307 - Transparently handle the X-variant commands when checking <Limit>
  permissions.  The fix for this issue has been reimplemented to be more
  transparent; some existing configurations were broken by the previous
  implementation.
- Bug 3329 - Support the "vendor-id" SFTP extension.
- Bug 3332 - Segfault in mod_wrap when TCPAccessFiles do not exist and client
  sends USER for account which does not exist.
- Bug 3333 - mod_sql_mysql should support calling stored procedures better.
- Bug 3337 - <Directory> sections with a trailing directory name of one
  character have <Limit> problems.  This is regression caused by Bug#3146.
- Bug 3331 - Update bundled libtool to 2.2.4.
- Bug 3341 - mod_wrap2 segfaults when a valid user retries the USER command.
- Bug 3342 - FEAT response contains LF without preceding CR.
- Bug 3306 - ECONNREFUSED while handling SIGHUP.
- Bug 3345 - mod_sftp returns EACCES rather than ENOENT for an OPEN request
  for a nonexistent file.
- Bug 3344 - Support SHA256, SHA512 passwords in databases.
- Bug 3348 - Rewriting of home directories via RewriteHome does not work for
  chrooted sessions.
- Bug 3349 - SSL_SESSION_cmp not available in OpenSSL 1.0.0 betas.
- Bug 3350 - Segfault caused by scrubbing zero-length portion of memory.
- Bug 3347 - mod_auth_file handles 'getgroups' request incorrectly.
- Bug 3351 - Nonchrooted logins on HPUX do not get proper UID/GID.
- Bug 3352 - mod_sftp does not reject/close connections that have been rejected
  by mod_wrap.

1.3.3rc2 - Released 20-Oct-2009
--------------------------------
- Bug 3263 - Supplying option SFTPRekey timeout parameter causes segmentation
  fault.
- Bug 3265 - SFTP requests are logged to ExtendedLog without regard to classes.
- Bug 2758 - ProFTPD doesn't always pay attention to AccessDenyMsg.
- Bug 3266 - Support "implicit" FTPS.
- Bug 2070 - AuthAliasOnly off in <Global> section kills anonymous logins.
- Bug 3268 - Files whose names start with whitespace are not listed properly.
- Bug 1908 - ExtendedLog to work properly in <Anonymous> context.
- Bug 3269 - RewriteCondition OR/ornext flag does not work.
- Bug 3254 - NLST/LIST and symbolic link problem.
- Bug 3272 - Avoid encoding if to/from charsets are the same.
- Bug 3274 - Timestamp formatting in TransferLog needs padded day-of-month.
- Bug 3270 - Lost connections to databases not correctly handled.  This
  also adds support for a new "noReconnect" SQLOption.
- Bug 3275 - Improper SSL/TLS certificate subjectAltName verification.
- Bug 3252 - %F/%f Display variables can report wrong size on 64-bit systems.
- Bug 3278 - Aborted data transfers not reflected in RADIUS accounting.
- Bug 3282 - With "SQLNegativeCache on", mod_sql will look up wrong cached
  user value for subsequent USER commands.
- Bug 3284 - Slower transfers of multiple small file transfers after upgrade
  from 1.3.0a to 1.3.2a.
- Bug 3279 - .ftpaccess configurations not merged properly with existing
  configuration.
- Bug 3287 - MaxTransfersPerHost, MaxTransfersPerUser directives not supported
  properly.
- Bug 2013 - Track RFC2228 sessions in scoreboard.  The scoreboard entry
  format now has a 'protocol' field, for tracking 'ftp' and 'ftps'.
- Bug 3286 - Client command field in scoreboard entry too short for SSH2/SFTP
  commands.
- Bug 3229 - LangDefault does not accept any setting on FreeBSD.
- Bug 2368 - Allow contrib modules to extend mod_sql's SQLAuthTypes.  This
  also includes a new mod_sql_passwd contrib module which can handle
  hex- and base64-encoded MD5 and SHA1 passwords, without the leading
  "{digest}" prefix required by the mod_sql OpenSSL SQLAuthType.
- Bug 3292 - "Incorrect MAC received on packet" error using AES CTR ciphers.
- Bug 3293 - SFTPCipher arcfour256 does not work properly.
- Bug 3294 - Support configurable HiddenStores prefixes.
- Bug 3295 - proftpd segfaults when STAT is used with ListOptions "-1".
- Bug 3296 - mod_quotatab should reject an upload via APPE if the quota is
  already exceeded.
- Bug 3297 - Symlinks to directories which end in trailing slashes may not be
  handled properly.
- Bug 3298 - QuotaExcludeFilter directive ignored by mod_quotatab.
- Bug 3290 - Change default mod_sql connection policy to open database
  connection on first use.
- Bug 3281 - TimeoutLogin not handled properly by mod_ban.
- Bug 3213 - Use locale-sensitive libncursesw library for ftptop where
  available.
- Bug 3214 - ftpwho/ftptop truncate UTF8 strings due to byte, versus character,
  lengths.
- Bug 3300 - Support disabling use of S_RLOGIN when calling AIX
  loginrestrictions().  A new AuthUnixOptions directive is added to support
  just this one setting, 'aixNoRLogin'.

1.3.3rc1 - Released 30-Jun-2009
--------------------------------
- Bug 1801 - Faulty SQLConnectInfo PERCALL policy - connections not closed
  after each call.
- Bug 2894 - Deprecate the AnonymousGroup directive.
- Bug 3123 - Use PQescapeStringConn() rather than PQescapeString().
- Bug 3133 - mod_facts should advertise TVFS support in the FEAT response.
- Bug 3128 - mod_sql_sqlite should use transactions for INSERT/UPDATE
  statements.
- Bug 3155 - Change the IdentLookups default to 'off'.  The RFC1413 IDENT
  lookup adds latency to the login process, so much so that it is a FAQ
  to configure "IdentLookups off".  In addition, the IDENT protocol is not
  secure; it can easily be spoofed using man-in-the-middle attacks.  Sites
  that require IDENT lookups must now explicitly configure "IdentLookups on".
- Bug 3156 - Allow resumed downloads when HiddenStore is in effect.
- Bug 3170 - RewriteMap unescape URL encoding broken by RewriteCondition
  backreference handling.
- Bug 2728 - Support for variables in ServerIdent directive.  The %L, %V,
  and %v variables are now supported for ServerIdent identity strings.
- Bug 3178 - mod_wrap2 does not handle IPv4-mapped IPv6 addresses.
- Bug 3179 - Restarted proftpd using mod_shaper will segfault.
- Bug 2720 - HideUser/HideGroup should be more flexible.
- Bug 3183 - Incorrect logging to wtmp.
- Bug 2608 - DNS should not be used for "server config" address discovery.
  A new -S command-line option has been added, for specifying the IP address
  to use for the host, rather than using DNS to resolve the host IP address
  from the hostname.
- Bug 3184 - When started in a chroot, proftpd fails to set transfer buffer
  size.
- Added mod_sftp, mod_sftp_pam, and mod_sftp_sql to the contrib modules.
- Bug 3185 - mod_wrap2 does not honour partial DNS name in access files.
  This appears to have been a regression caused by the fix for Bug#3178.
- Bug 3186 - Support use of <IfClass> directive with mod_ban.  The
  BanEngine directive can now appear in an <IfClass> section, in order
  to exclude connection classes from mod_ban's rules.
- Bug 3188 - prxs broken due to typo.
- Bug 3154 - Update bundled libtool version.  The bundled libltdl version
  has been updated to libtool 1.5.26.
- Bug 3111 - Support SSL/TLS server certificates stored in PKCS#12 files.
- Bug 3189 - Linker errors occur when using "make -j" parallel builds.
  ProFTPD now builds successfully using "make -jN", where N is the number
  of simultaneous build processes to use.
- Bug 3176 - Postgres chokes on standard charset names.
- Bug 3129 - Support configurable scoreboard scrubbing.  A new configuration
  directive, ScoreboardScrub, can be used to control whether the ScoreboardFile
  is scrubbed, and how often.
- Bug 3190 - MLSD/MLST do not honor <Limit> configurations.
- Bug 3196 - mod_quotatab does not honor last group in supplemental group list.
- Bug 3203 - Missing SQL backend modules can lead to null pointer segfault in
  mod_sql.
- Bug 3204 - Better support for installation and libs in prxs.  The prxs
  tool now handles the $Libraries$ build system hints in source files,
  and honors the DESTDIR environment variable.
- Bug 3167 - Support rewriting of home directories.
- Bug 2985 - Newest .spec file requires relatively current version of RPM.
  The provided .spec file now requires RPM 4.2 or later.
- Bug 3207 - Support for SSL/TLS session caching across processes/machines.
  The mod_tls module now supports a TLSSessionCache directive, and an API
  for modules to provide external SSL session caching mechanisms.
- Bug 3210 - Data transfers protected by SSL/TLS should reuse the control
  connection SSL session.  If the TLSRequired policy allows/requires SSL/TLS
  protections on data transfers, then reuse of the SSL session from the
  control connection is now enforced.  Use "TLSOptions NoSessionReuseRequired"
  to relax this requirement.
- Bug 3215 - mod_wrap2_sql should support comma-delimited lists of clients.
  This is the same as Bug#3048, only it affects the mod_wrap2_sql module.
- Bug 2613 - Configure script should not append '/proftpd' to the
  --localstatedir.
- Bug 2680 - Add support for <VirtualHost 0.0.0.0>.
- Bug 3187 - Inconsistent mod_ban logging and display when using
  "BanEngine off" in an <IfClass> configuration.
- Bug 3219 - Support environment variable substitutions in mod_rewrite rules.
  RewriteCondition and RewriteRules can now contain "%{ENV:var}" style
  strings for environment variable substitution.
- Bug 3221 - Command line defines (-D/--define) are lost on SIGHUP.
- Bug 3028 - Unable to escape special characters in RewriteRule substitution
  string.
- Bug 3161 - Updating tallies for deleted files should occur based on file
  ownership.
- Bug 2067 - Allow/Deny Filters should be supported in the <Limit> context.
- Bug 2434 - Buggy interaction between custom SQLUserInfo and 'userset'
  SQLAuthenticate parameter.  See the SQLUserInfo description for more details.
- Bug 3226 - HideFiles directive not working properly in <Anonymous> sections.
- Bug 3231 - Use getgrset(3) on AIX to emulate getgrouplist(3).
- Bug 3043 - SQLGroupInfo should allow custom queries.  See the SQLGroupInfo
  description for more information.
- Bug 2178 - Extend TLSRequired for <Directory> and .ftpaccess contexts.
- Bug 3209 - mod_wrap2 should support the 'spawn' feature (or equivalent) of
  tcpwrappers.  Using mod_wrap/mod_wrap2 in conjunction with the mod_exec
  module, this is now possible.
- Bug 3225 - Opening of files during restart can inappropriately use
  stdin/stdout/stderr descriptors, leading to bad behavior.  The "bad behavior"
  can manifest as server shutdown (due to mod_tls errors),
  "Bad file descriptor" log messages, etc.
- Bug 3234 - SSL connections can cause 100% CPU usage.
- Bug 3233 - Dynamic config causes many copies of static configs to be merged.
- Bug 3086 - mod_quotatab write locking is ineffective.
- Bug 3029 - Support a RewriteCondition variable for renames.
- Bug 3230 - Differentiate among protocol connections in DelayTable.
- Bug 3032 - CR character allowed in filename but not shown.
- Bug 3237 - "error setting IPV6_V6ONLY: Protocol not available" message
  filling up log file.
- Added mod_shaper, mod_exec to the contrib modules.
- Bug 3249 - mod_ban support for TimeoutLogin.
- Bug 3253 - Support for %S variable in SQL queries.
- Bug 3247 - "TLSRequired auth" and "TLSOptions AllowPerUser" are incompatible.
- Bug 3256 - "SO_OOBINLINE" error occurring again.  This is a regression of
  Bug 2332 caused by code movement in 1.3.2.
- Bug 3258 - Log cluttered with "using sendfile capability" messages.
- Bug 3261 - Badly formatted TLSRenegotiate directive causes proftpd to hang.
- Bug 3257 - CAP_AUDIT_WRITE capability needed for some PAM modules.
- Bug 3243 - Broken support for AllowOverride per user/group/class conditionals.
  The user/group/class conditional arguments to the AllowOverride directive
  were not properly honored.  The fix for this is to remove all support in
  the AllowOverride directive, and instead use mod_ifsession for conditionals.

1.3.2 - Released 5-Feb-2009
--------------------------------
- Bug 3169 - Multiple RewriteRules for the same RewriteCondition not processed
  properly.
- Bug 3171 - ExtendedLog should log full SITE command using %m.
- Bug 3173 - Encoding-dependent SQL injection vulnerability.

1.3.2rc4 - Released 23-Jan-2009
--------------------------------
- Bug 2045 - SQLShowInfo should not be displayed when query returns no data.
- Bug 2915 - mod_rewrite does not work well for SITE commands.
- Bug 1636 - GroupRatio does not check user's supplemental group membership.
- Bug 3137 - ProFTPD does not log filename %f for uploaded files.
- Bug 3142 - "Invalid number of arguments MFMT" due to spaces in path argument.
- Bug 3144 - mod_dynmasq returns same IP address, even though actual IP
  address has changed.
- Bug 3040 - Support for CreateHome parent directories owned by user.
- Added Russian translation.
- Bug 2020 - HideFiles sometimes fails.
- Bug 3146 - <Directory> paths using glob characters may not match as expected.
- Bug 3147 - Comma-delimited commands in <Limit> sections not handled properly.
- Bug 3149 - Bad handling of %p, %V, and %v variables in mod_sql.
- Bug 3150 - mod_facl erroneously assumes no permissions, rather than all
  permissions, in some cases.
- Bug 3159 - mod_rewrite build fails due to missing mode argument in open(2)
  call on some platforms.

1.3.2rc3 - Released 20-Nov-2008
--------------------------------
- Bug 3114 - Bad handling of uid/gid parameters for CreateHome.
- Bug 3115 - Cross-site request forgery.
- Bug 3116 - SQLNegativeCache with no group info can cause segfault.
- Bug 3117 - Authentication improperly allowed (Bug#2922 regression).
- Bug 3119 - Search for libcap2 in addition to libcap for mod_cap support.
- Bug 3120 - WrapTables not allowed in <Anonymous> context.
- Bug 3122 - iconv() not detected properly on FreeBSD when --enable-nls is used.
- Bug 3124 - mod_sql improperly substitutes variables in user/group names.
- Bug 3089 - Memory pool double-free on session exit after aborted data
  transfer.
- Bug 3092 - FSIO API needs mechanism for allowing registered FS handlers to
  permit atomic renames.
- Bug 2767 - gcc 4.0/amd64 warnings.
- Bug 3126 - Segfault in mod_sql_sqlite when user belongs to multiple groups.
- Bug 3130 - HideFiles can cause segfault.
- Bug 3131 - Session process uses 100% CPU after aborted transfer.
- Bug 3132 - Handling of SIGABRT signal leads to endless loop.
- Bug 3073 - Command arguments not decoded properly in some places.
- Bug 3135 - Aborting a download can lead to segfault in some cases.

1.3.2rc2 - Released 17-Sep-2008
--------------------------------
- Added Chinese translation
- Bug 3076 - RPM build failing on 64 bit OS due to incomplete .spec.
- Bug 3082 - Use "DEFAULT" keyword instead of "ALL" for Trace directive.
  Hopefully the "DEFAULT" keyword will be more accurate, more descriptive
  of the actual functionality triggered by the keyword.
- Bug 3083 - Multiple issues with handling of <Class> definitions.
- Bug 3077 - Transparently handle the X-variant commands when checking
  <Limit> permissions.
- Bug 3036 - Quota information not persisted if session ends abruptly.
- Bug 3094 - Perform unidirectional SSL/TLS shutdown on data connections.
- Bug 3096 - libcap version errors on newer Linux kernel.
- Bug 3074 - Support configure option for pkgconfig .pc file install
  location.
- Bug 3095 - TLSPassphraseProvider port number truncated.
- Bug 3099 - Add trace logging of filesystem permission errors.  To see
  this additional logging, use Trace logging, and configure it to log
  the "fileperms" log channel.
- Bug 3100 - Support ftpmail options for sending emails only for specific
  users.  See doc/contrib/ftpmail.html for more details.
- Bug 3030 - GroupOwner should work for all groups.  Previously, GroupOwner
  (without using UserOwner) could fail, if the user did not belong to
  the specified group.  Now proftpd will automatically detect, when
  handling GroupOwner, when root privileges need to be used for the
  configured group.
- Bug 3101 - mod_wrap2 does not compile on FreeBSD with custom includes.
- Bug 3098 - Socket descriptor leak when using syslog logging, especially at
  SyslogLevel 'notice' or higher.
- Bug 3055 - Support Display variable for specifying the timestamp format.
  See doc/howto/DisplayFiles.html for more information.
- Bug 2537 - mod_sql does not support %{...}t variable.  SQLNamedQuery
  statements can now use "%{time:...}" variables for formatting time strings
  using strftime(3).
- Bug 2564 - Improper logging of "max connections per host".  The issue was
  one of the timing of the logging of the "Login successful" message.  Now
  it happens as part of a LOG_CMD handler for the PASS command.
- Bug 3104 - Syslog logging does not work on Mac OS X.
- Bug 2991 - Need a `prxs' (ProFTPD Extensions) command-line tool for building
  shared modules without proftpd source.
- Bug 3106 - Add support for Mac OSX 10.5 sendfile.
- Bug 3107 - TLSProtocol supports misleading "SSLv23" parameter.
- Bug 3108 - Support removing MLST from FEAT list.  The mod_facts module
  now supports a FactsAdvertise directive; see doc/modules/mod_facts.html
  for details.
- Bug 3109 - Errors with file uploads logged but not reported to clients.
- Bug 3112 - Uploaded files are not removed if close() fails.

1.3.2rc1 - Released 15-Apr-2008
--------------------------------
- Bug 2978 - Support more verbose OpenSSL diagnostic logging.  There is now
  support for an "EnableDiags" TLSOptions setting, which logs a lot of
  SSL/TLS protocol information to the TLSLog.
- Bug 2969 - Allow APPE after REST.
- Bug 2983 - Use getgrouplist(3) for group lookup, if available.  This may
  potentially speed up the group membership lookup on some systems.
- Bug 2984 - mod_auth_file uid2name() does not cache results causing slow LIST
  response.
- Bug 2925 - Add caching of IP address and DNS name lookups.  This may help
  speed up data transfers, especially rapid-fire data transfers as used by
  "download accelerators".
- Bug 2979 - Ability to ban clients which connect too often.  The mod_ban
  module now supports a "ClientConnectRate" BanOnEvent rule.
- Bug 2987 - Verbose ban information (i.e. 'ftpdctl ban info -v') not working
  on FreeBSD.
- Bug 2986 - Authoritative PAM is not honored.
- Bug 2988 - mod_wrap2_file ignores "ALL" keyword.
- Bug 2982 - Support limit on number of simultaneous file transfers from one
  client.  Two new configuration directives, MaxTransfersPerHost and
  MaxTransfersPerUser, have been added.
- Bug 2386 - Controls should use kernel-enforced credentials where possible.
- Added mod_dynmasq contrib module.  See doc/contrib/mod_dynmasq.html for
  more information.
- Bug 2968 - Ability to allow protection on control channel, but reject
  protection on data channel.  See doc/contrib/mod_tls.html#TLSRequired
  for details.
- Added mod_unique_id contrib module.  See doc/contrib/mod_unique_id.html
  for details.
- Bug #2990 - TLSCryptoDevice does not work.
- Bug #2989 - Unable to authenticate users if RadiusUserInfo is not configured.
- Bug #2937 - Should list modules (with versions) for modules loaded as DSOs.
  The -vv command-line option now shows all modules (and versions), both
  static and shared.  See the RELEASE_NOTES for more details.
- Bug #2993 - Unable to compile 1.3.1 on Debian unstable/amd64.  The configure
  script was brokenly checking for the umode_t data type, which is not needed
  by the proftpd source code.
- Bug #2992 - The %f LogFormat variable expanded improperly to "-" for
  SITE CHMOD.
- Bug #2995 - The %f LogFormat variable expanded to same file for RNFR and
  RNTO.
- Bug #2996 - Requirement for same OpenSSL header, library version in mod_tls
  too restrictive.  If differences are detected now, the difference is logged,
  but the daemon will start up.
- Bug 3005 - OOB abort closes the control connection.
- Bug 3004 - 'ScanOnLogin' QuotaOption does not honor QuotaDirectoryTally
  directive.
- Bug 3006 - 'ScanOnLogin' QuotaOption may try to update a nonexistent tally
  record.
- Bug 3001 - Incomplete downloads not logged properly in TransferLog if
  sendfile is used.
- Bug 3012 - SITE UTIME should support YYYYMMDDhhmmss format.
- Bug 3013 - "TLSOptions AllowPerUser" not working as expected.
- Bug 3019 - DisplayLogin in <Anonymous> section not displayed properly.
- Bug 3015 - Support for RFC3659.  There is a new module, mod_facts, which
  implements the RFC3659 commands of MLSD and MLST, as well as the MFF and
  MFMT commands from an Internet Draft.
- Bug 2894 - The AnonymousGroup directive has been marked for deprecation,
  and will be removed in a future release.
- Bug 3003 - Fallback to normal transmission in case of sendfile EOVERFLOW
  error missing.
- Bug 2874 - Data transfer buffers should be allocated at startup, not at
  compile time.
- Bug 3014 - Optionally set PAM_TTY item when using PAM.  Use
  "AuthPAMOptions NoTTY" to disable this.
- Bug 2741 - Apply TimeoutNoTransfer, TimeoutStalled, TimeoutIdle to
  <Anonymous> section.
- Bug 2997 - Uploading files with "~" causes harmless but annoying log
  message.
- Bug 2889 - Update SQLLog so that RNTO stores the path when using the
  %F variable.
- Bug 2731 - Add ability to set process priority for file transfers.  A new
  TransferPriority directive has been added, which can be used to set the
  scheduling priority of the session process during file transfers.
- Bug 3020 - Server replies to NLST with 450 at the wrong time.
- Bug 1771 - mod_ratio compile warnings.
- Bug 1973 - mod_ratio uses the too-small int datatype for tracking bytes.
  The mod_ratio module has been updated to use off_t, instead of int, for
  tracking bytes.
- Bug 1896 - Check AIX account status.  The AIX-specific loginrestrictions()
  and passwdexpired() functions, if present, are now used by the mod_auth_unix
  module during login.
- Bug 2453 - Separate RFC1413 code into mod_ident module.
- Bug 3023 - Allow uploading to /dev/null.  This allows testing of network
  link speeds by uploading directly to /dev/null on the server.
- Bug 3022 - Timed SQL connections don't reconnect to database.
- Added mod_sql_sqlite contrib module, for authenticating using a SQLite
  database.  See doc/contrib/mod_sql_sqlite.html for more details.
- Added mod_sql_odbc contrib module, for connecting to a database via
  ODBC drivers.  See doc/contrib/mod_sql_odbc.html for more information.
- Bug 3025 - Using %b in a SQLNamedQuery does not properly log the file size
  for DELE.
- Bug 3026 - RewriteCondition does not negate -d -f -s tests.
- Bug 3027 - Unmatched backreferences are not handled properly in RewriteRules.
  Unmatched backreferences are now replaced with empty strings.
- Bug 2999 - Data transfer not aborted when control connection is closed.
- Bug 3031 - IPv4-mapped IPv6 connections not matched properly against IPv4
  glob ACLs.
- Bug 3033 - Class rules not honoring '!' negation character.
- Bug 3034 - Rewritten command parameters need to be set in multiple places.
- Bug 2577 - IPv6 support should be enabled by default.  IPv6 support is
  now enabled by default in the proftpd build, but the shipping
  proftpd.conf has:

    UseIPv6 off

  To disable IPv6 support completely at build time, use the --disable-ipv6
  configure option.
- Bug 2000 - mod_cap should not use bundled libcap.  Now if a system libcap
  is present, that system library will be used instead of the bundled libcap.
  If no system libcap is present, the bundled libcap will be used.
- Bug 3044 - Segfault if mod_delay fails to load DelayTable.
- Bug 3048 - mod_wrap2_file should support comma-delimited lists of clients.
- Bug 3045 - "QuotaOptions ScanOnLogin" does not work for 'class' or
  'all' limits.
- Bug 3047 - BanOnEvent should support optional ban message.  Now messages
  for individual ban rules can be configured, in addition to the BanMessage
  directive.
- Added contrib/ftpmail, a Perl script which reads a TransferLog FIFO and
  sends automatic email notifications whenever uploads occur.  See
  doc/contrib/ftpmail.html for more details.
- Bug 3050 - Support use of OpenSSL in FIPS mode.  See doc/howto/TLS.html for
  details on how to use FIPS mode.
- Bug 3051 - mod_quotatab incorrectly reduces file count on rename.
- Bug 2840 - Online Certificate Status Protocol (OCSP) support.
- Bug 3058 - Handling of OPTS command results in badly set values in code.
- Bug 3059 - Wrong handling of UTF8 conversions.
- Bug 3061 - Segfault in mod_quotatab_sql if the SQL query returns NULL
  bytes/files values.
- Bug 3056 - Support non-UTF8 encoding and character sets.  See
  doc/modules/mod_lang.html for more information on the UseEncoding directive.
- Bug 3064 - Better handling of 0xFF character for Cyrillic, non-UTF8 charsets.
  These character sets use the same value as the Telnet IAC character in
  the alphabet.  RFC959 states that FTP control messages must support Telnet
  characters; this requirement causes problems for the character sets.
  This the RFC959 requirement is relaxed if --enable-nls is used, and if
  one of the problematic character sets is configured.

1.3.1 - Released 5-Oct-2007
--------------------------------
- Bug 2944 - mod_sql_mysql fails to compile due to missing quotation.
- Bug 2946 - Anonymous logins fail if the mod_facl module is enabled.
- Bug 2947 - SIGBUS on Mac OS X when dynamically loading shared libs.
- Bug 2950 - Hostname with multiple IP addresses might cause "ai_family not
  supported" error if IPv6 support enabled.
- Bug 2955 - Undeclared identifier MAP_FAILED for mod_delay on AIX.
- Bug 2958 - mod_wrap2 does not handle multiple rules in access files.
- Bug 2963 - Use of -A option for LIST/NLST commands not cleared for
  subsequent commands.
- Bug 2964 - Building RPM fails because of *snprintf trying to be redefined.
  This is actually caused by a particular combination of compiler flags
  (-O2 and -Wp,-D_FORTIFY_SOURCE=2), which are used by the `rpmbuild'
  command in some Linux releases.
- Bug 2974 - Install error if multiple modules, using their own build script,
  are built as shared modules.
- Bug 2981 - Command-line long options --ipv4 and --ipv6 do not work.
- Bug 2795 - Improvements to RPM .spec file to build more of the modules, plus
  better optional packaging organization.

1.3.1rc3 - Released 04-Jul-2007
--------------------------------
- Bug 2875 - Malformed getopt checks cause compilation errors in getopt.c.
- Bug 2877 - ServerType 'inetd' results in "getnameinfo error: ai_family not
  supported" errors in log.
- Bug 2878 - Error compiling proftpd on Solaris 2.9 using --with-lastlog.
- Bug 2881 - ProFTPD does not support OPTS UTF8 command when --enable-nls is
  used.
- Bug 2883 - Problem with locale and SQL database queries.
- Bug 2893 - ProFTPD can use the wrong group data if the user name changes.
- Bug 2897 - mod_quotatab subtracts size of deleted file from bytes-transferred
  tally.
- Bug 2902 - Stack read overrun in mod_xfer on 32bit platform.  Use an
  explicit compiler cast to ensure that the proper data type size is used
  in the arguments for a variadic function.
- Bug 2906 - RewriteCondition backreferences not properly substituted.
- Bug 2913 - TYPE command does not clear ASCII flag from LIST/NLST commands.
- Bug 2911 - NLST on a nonexistent path, followed by an NLST on an existing
  file, causes segfault.
- Bug 2922 - Auth API allows one auth module to authenticate user data provided
  by a different auth module.
- Bug 2921 - NLST fails if using POSIX ACLs.  The mod_ls module, when
  handling the NLST command, was using an unnecessary access(2) check.
- Bug 2864 - DisplayLogin should work regardless of chroot.  This now works
  for DisplayQuit and DisplayTransferFiles as well.
- Bug 2920 - ABOR command not handled during data transfer.
- Bug 2924 - DeleteAbortedStores doesn't work when the ABOR command is used.
- Bug 2890 - SystemLog permission errors on SIGHUP when mod_tls is enabled.
- Bug 2932 - Syslog contains "error setting IPV6_V6ONLY: Protocol not
  available".  Check the IPV6_V6ONLY socket option first, and only attempt
  to disable it if needed.  Also use the IPPROTO_IPV6 socket level.
- Bug 2934 - Function perm_copy_fd() not in older Linux libacl versions.
- Bug 2923 - ftptop display flickers if delay is greater than 25 seconds.
- Bug 2900 - Some kernels incorrectly reuse IPv6 ports for EPSV command.
- Bug 2935 - DELE command doesn't check file stat result before logging.
- Bug 2938 - mod_wrap2 does not honor WrapTables for <Anonymous> logins.
- Bug 2939 - Anonymous restrictions apply after a failed anonymous login
  followed by a successful normal user login.
- Bug 2942 - BanLog directive does not accept "none" parameter.

1.3.1rc2 - Released 12-Jan-2007
--------------------------------
- Bug 2856 - Support for RADIUS NAS-Identifier attribute.
- Bug 2849 - Error msg "Not owner" returned by "SIZE in ASCII mode" is
  misleading.
- Bug 2857 - Failure to properly unregister event handlers leads to segfault
  after restarts.
- Bug 2869 - mod_sql botches WHERE clauses.
- Bug 2872 - CreateHome doesn't recreate symlinks from skeleton properly.

1.3.1rc1 - Released 12-Dec-2006
--------------------------------
- Bug 2766 - Support for automatic stack trace if SIGSEGV is received.
- Bug 2714 - mod_auth_file munges AuthUserFile, AuthGroupFile records.
- Bug 2721 - mod_auth_unix does not behave properly when first in AuthOrder.
- Bug 2535 - Compare directives using integer comparisons when possible to
  improve performance.
- Bug 2753 - CCC not closing SSL/TLS connection correctly.
- Bug 2654 - FEAT command should be subject to <Limit>.
- Bug 2740 - TYPE command not allowed before USER/PASS, causes problem for
  `ftp -n'.
- Bug 2777 - ProFTPD does handle data sockets properly on FreeBSD 6.
- Bug 2664 - Add 'delay info' ftpdctl action for showing DelayTable values.
  This patch also added a 'delay reset' ftpdctl action, for clearing the
  DelayTable.
- Bug 2769 - mod_auth_pam needs a patch to allow pam_group to work.
- Bug 2599 - Support for using OpenSSL "engines".
- Bug 2611 - CreateHome should allow non-root-owned parent directories.
- Bug 2686 - Allow CCC command but still require SSL/TLS protection during
  authentication.
- Bug 2628 - SQLHomedirOnDemand should be deprecated.  The CreateHome
  directive should be used instead.
- Bug 2627 - Support for RADIUS quotatab module.  The mod_quotatab_radius
  module has been added to the contrib/ directory.  See README.modules
  and doc/contrib/mod_quotatab_radius.html for more information.
- Bug 2651 - LogFormat should support variable for logging the response
  message.  A new %S logging variable has been added.
- Bug 2447 - HAVE_OPENSSL should be managed by configure.  There is a
  new configure option, --enable-openssl, which is honored by mod_ldap
  and mod_sql.  This configure option can be used instead of using
  the HAVE_OPENSSL CFLAGS variable, although HAVE_OPENSSL will still work.
- Bug 2733 - IP TOS not being set for data transfers.  Other socket-level
  options were not being properly honored for data transfers, too.
- Added mod_ban.  See doc/contrib/mod_ban.html for more details.
- Enhanced the mod_sql API to allow other modules (such as mod_conf_sql)
  to make fuller use of SQL databases via mod_sql.
- Bug 2713 - Ability to check a user's existing disk bytes/files usage and
  update tally accordingly.  The mod_quotatab module now has a QuotaOptions
  directive, one of whose parameters is ScanOnLogin, which directs the
  module to update existing tallies after scanning the user's home
  directory.
- Bug 2786 - REST in ASCII mode returns error but leaves session in
  inconsistent state.
- Bug 2785 - IPv4-mapped IPv6 network ACLs not matched properly against
  IPv4 connections.
- Bug 2732 - Support for DisplayChdir, rather than DisplayFirstChdir.
- Bug 2506 - Better ability to configure what sort of debug output to generate.
  This is done via the new Trace and TraceLog directives.
- Bug 2514 - Trouble with mod_tls and DSA certificates.
- Bug 2792 - ProFTPD fails after SIGHUP signal when Controls support is
  enabled.
- Bug 2775 - Support for DisplayFileTransfer directive.
- Bug 2793 - LogFormat variable for the ProFTPD version.  This adds a
  "%{version}" variable to the LogFormat directive.
- Bug 2797 - Add ability to force cleaning the scoreboard.  This can now
  be done using "ftpdctl scoreboard scrub".
- Bug 2800 - free_proc_title() in developer build tries to free strings from
  pool allocated by mod_tls.
- Bug 2801 - Error compiling proftpd on NetBSD 3.0/sparc64.
- Bug 2687 - Support for more efficient group table schema.  A new
  directive, SQLOptions, has been added.  One possible parameter of this
  directive is 'useNormalizedGroupSchema', in which case mod_sql will
  process the group info table in a more efficient manner.
- Bug 2798 - MDTM should return time in GMT.  MDTM responses now always use GMT.
- Bug 2784 - Ability to specify MySQL Unix domain socket path.
- Bug 2610 - Support for logging to /var/log/lastlog.  See the RELEASE_NOTES
  for more details on how to use this feature.
- Bug 2710 - ProFTPD should install its header files into the installation
  location.  The `make install' target now causes proftpd header files,
  including config.h, to be installed into a include/proftpd/ directory
  in the installation location.
- Bug 2626 - ERROR macro collision can cause compiler errors on HP-UX.
  The ERROR, DECLINED, and HANDLED macros have been renamed PR_ERROR,
  PR_DECLINED, and PR_HANDLED, respectively.  Compatibility macros for
  older contrib modules are available.
- Bug 2807 - mod_sql processes SQLLog QUIT query twice.  This bug is a
  consequence of Bug 1965.
- Bug 2810 - Incorrect use of assignment instead of comparison in mod_wrap.
- Bug 2803 - mod_auth_file does not properly iterate through AuthUserFile
  entries.
- Bug 2809 - conf.h should be included before mysql.h in mod_sql_mysql.c.
- Bug 2774 - Idle clients exhibit excessive usage of system resources.
  This occurs because of interrupted system calls, which trigger tightly
  spinning retry loops within the process.  The ability to tune the delay
  used in these retry loops has been added to address this behavior.
- Added mod_wrap2, mod_wrap2_file, and mod_wrap2_sql.  See
  doc/contrib/mod_wrap2.html for more details.
- Bug 2825 - SSL/TLS CRLs are not working properly.
- Bug 2835 - Group quotas not honored for supplemental group membership.
- Bug 2837 - Defines improperly persist across daemon restarts.
- Bug 2839 - ProFTPD seems to re-read the file two times in RETR command.
  The problem was one where sendfile() was being used, and the sendfile()
  called failed for some reason.  In that case, proftpd would fall back
  to transmitting the data via normal, non-sendfile() means.  If the
  sendfile() call had actually sent data to the client already, this
  fallback attempt would result in the client receiving too much data.
  Now, if there was an error using sendfile(), proftpd logs the error
  and considers it a failed transfer due to an I/O error.
- Bug 2756 - Support for TLSPassPhraseProvider.
- Bug 2799 - SQLNamedQuery should support environment variables.  SQL
  queries defined using the SQLNamedQuery directive can now use
  "%{env:VAR}" to have the environment variable VAR substituted into the
  query.
- Bug 2828 - Support variables in SQL Where directives.  Now the variables
  supported for SQLNamedQuery statements, except for "%{n}" numeric
  references, are also supported for the SQLGroupWhereClause and
  SQLUserWhereClause directives.
- Bug 2842 - Filesystem statcache is not correctly caching return value of
  stat().
- Bug 2817 - Ability to disable IPv6 support at runtime.  You can now
  configure "UseIPv6 off" in your proftpd.conf to disable IPv6 support
  (assuming proftpd was compiled using --enable-ipv6).
- Bug 2847 - HiddenStores files not properly removed if data transfer times
  out.
- Bug 2848 - Unable to properly parse config files using Windows-style line
  endings.  Such line endings can appear in the proftpd.conf if the file
  is transferred using Windows machines, or using FTP clients that do not
  properly translate CRLF to LF when handling ASCII files.
- Bug 2850 - Small event pool allocation on 64-bit machine leads to segfault
  on startup.
- Bug 2860 - Failure to check for data length in mod_tls could lead to remote
  buffer overwriting.
- Bug 2863 - LIST of nonexistent file causes RST on data channel.
- Bug 2862 - NLST / returns a listing of the current directory.
- Bug 2867 - Local authorized user buffer overflow in Controls request
  handling.

1.3.0a - Released 27-Nov-2006
--------------------------------
- Bug 2858 - CVE-2006-5815: remote code execution in ProFTPD.

1.3.0 - Released 16-Apr-2006
--------------------------------
- Bug 2733 - libtool requires sh/bash.
- Bug 2770 - FreeBSD compiler warning that "__GLIBC__" is not defined.
- Bug 2771 - FreeBSD compiler warning about undeclared fgetpwent/fgetgrent
  functions.
- Bug 2772 - FreeBSD compiler warning that "_FILE_OFFSET_BITS" is not defined.

1.3.0rc5 - Released 18-Mar-2006
--------------------------------
- Bug 2757 - Add support for quota modules to RPM spec.
- Bug 2759 - Adding --with-includes to configure can cause problems when
  building with other packages.  Fixed so that CPPFLAGS and LDFLAGS are
  restored to their original settings after running the configure
  script.  This was a regression (of sorts) from fixing Bug #2708.
- Bug 2764 - REST command does not return an error for negative numbers.
- Bug 2717 - Wrong timestamp in logs for chrooted processes.  Ultimately
  this behavior looks to be a glibc bug.  In the meantime, the workaround
  is to manually set the TZ environment variable, if it is not already
  set, before calling chroot().  This bug appears to be specific to
  glibc, thus the workaround is only enabled on platforms using glibc-2.3
  or later.
- Bug 2765 - Child process segfaults while handling a SIGTERM.
- Bug 2723 - mod_delay causes process to hang on OS X when proftpd exits.

1.3.0rc4 - Released 01-Mar-2006
--------------------------------
- Bug 2703 - Disk quota exceeded for small files not being triggered.
- Bug 2706 - utmp/wtmp logging on NetBSD needs some tweaks.
- Bug 2708 - configure cannot detect some headers.  The configure
  script now adds the directories mentioned via the --with-includes
  and --with-libraries options to the CPPFLAGS and LDFLAGS environment
  variables.
- Bug 2711 - Controls socket detection broken.
- Bug 2712 - DisplayFirstChdir directive does not work.
- Bug 2705 - proftpd fails to log anything to syslog after dropping privs
  on Solaris.  This happens because of the default permissions on /dev/log
  on Solaris.
- Portability tweaks for Mac OS 10.4.
- Bug 2729 - Authoritative PAM authentication doesn't work.  The mod_auth_pam
  module still had code for supporting the deprecated AuthPAMAuthoritative
  directive.  As per Bug #2440, however, the AuthOrder directive should
  be used for configuring authoritativeness.  This fixes mod_auth_pam
  to behave properly using the new AuthOrder setting.
- Bug 2709 - mod_sql improperly strips spaces from names, allowing for
  confusing authentication.
- Bug 2735 - Allow REST 0 in ASCII mode.
- Bug 2746 - Data transfer function does not return error condition in case of
  read errors.
- Bug 2752 - FEAT reply not RFC 2389 compliant.

1.3.0rc3 - Released 31-Oct-2005
--------------------------------
- Bug 2660 - Add mod_facl in rpm spec file.
- Bug 2662 - OpenSolaris/Solaris 11 has TCP_CORK but not SOL_TCP.
- Bug 2667 - mod_tls handles SIGHUP badly.
- Bug 2668 - mod_ctrls fails to open socket during SIGHUP.
- Bug 2669 - mod_radius segfaults if PASS command sent with no USER command.
- Bug 2674 - mod_sql string escape problem during group lookups.
- Bug 2676 - configure option --disable-ipv6 enables IPv6.
- Bug 2685 - ListOptions' max parameters cannot be set higher than 255.
- Bug 2689 - Parser does not complain about unclosed configuration sections.
- Bug 2695 - Client IP/host is not logged when client exits.
- Bug 2697 - Improper SSL session shutdown sequence used for some FTPS clients.
- Bug 2682 - Signals can interrupt privilege switching.
- Bug 2692 - R_DUP response messages can break the FTP protocol responses.

1.3.0rc2 - Released 24-Jul-2005
--------------------------------
- Bug 2584 - mod_sql_postgres missing end-of-comment character.
- Bug 2587 - HideNoAccess does not work for DefaultRoot/<Anonymous> logins.
- Bug 2590 - AIX uses unsigned int for ULONG_MAX, causing printf format warning.
- Bug 2591 - wrong argument type in call to pr_log_debug in mod_delay.c on AIX.
- Bug 2593 - `make install-modules' does not honour DESTDIR environment variable.
- Bug 2596 - STAT command can cause segfault.
- Bug 2588 - AIX requires _USE_IRS #define to use hstrerror().
- Bug 2582 - ProFTPD on Tru64 with SIA does not call sia_ses_estab().
- Added new 'dns' control to mod_ctrls_admin, for enabling/disabling
  UseReverseDNS configuration at runtime.  See doc/contrib/mod_ctrls_admin.html
  for details.
- Bug 2605 - Compiler warnings/errors about missing typecasts on HP-UX.
- Bug 2589 - Makefile in modules/ directory is not portable.
- Bug 2598 - Build system should check for duplicate module requests.
- Bug 2585 - Proftpd does not write RFC 3164 compliant messages into /dev/log.
- Bug 2601 - mod_delay sometimes delays for a long time.
- Bug 2622 - Segfault seen randomly in mod_delay.
- Bug 2578 - ProFTPD does not listen on IPv6 addresses on FreeBSD.
- Bug 2624 - "fh_data" macro collision causes compiler error on Tru64 V5.1A.
- Bug 2250 - Add ports, compiling info to FreeBSD README.
- Bug 2631 - Segfault when using RadiusAcctServer.
- Bug 2632 - Invalid application of `sizeof' to an incomplete type on AIX.
- Bug 2637 - <Limit STAT> does not work.
- Bug 2636 - Data connection failure when handling STOR does not trigger
  error response.
- Bug 2639 - HiddenStores does not work.
- Bug 2630 - Use of mmap in mod_delay may be problematic on HP-UX.  This
  change adds locking of the DelayTable, which may (or may not) also
  help on other platforms.
- Bug 2644 - mod_sql_mysql should handle old MySQL password format more
  gracefully.  Starting with MySQL 4.1.1, the format for passwords stored
  using the MySQL PASSWORD() function changed.  This format change causes
  issues for sites that have passwords stored in the older format.  Users
  of mod_sql+mod_sql_mysql would see this as users being unable to login.
  Now, if compiled against MySQL 4.1.1 or later, mod_sql_mysql will first
  check the password using the current MySQL format; if that fails it
  will fall back to checking the old format.  Note that this only affects
  sites which have "SQLAuthTypes Backend" in their proftpd.conf.
- Bug 2647 - Improper "socklen_t" redefine for HP-UX when using X/Open.
- Fixed mod_sql bug where using SQLLog and SQLNamedQuery with the %L or
  %a variables, and logging the EXIT pseudo-command, would cause a segfault.
- Bug 2375 - Slow directory listing with several blank .ftpaccess files.
- Bug 2646 - ftpshut format string vulnerability.
- Bug 2645 - SQLShowInfo format string vulnerability.
- Bug 2560 - Reporting errors when user filesystem quota is exceeded.
- Bug 2653 - When MaxStoreFileSize is reached, error should be EDQUOT rather
  than EPERM.
- Bug 2657 - Segfault in tls_get_error() function in mod_tls.
- Bug 2658 - Segfault in mod_radius when using long password.

1.3.0rc1 - Released 10-Apr-2005
--------------------------------
- Bug 2449 - ProFTPD silently ignores extra command-line parameters
- Bug 2457 - Directory listing provides bad info when path ends with /.
- Bug 2458 - Bad handling of CreateHome parameters.
- Bug 2463 - mod_xfer doesn't check how many bytes it has written to disk.
- Bug 2476 - Incorrect detection of symbolic link loop across devices.
- Add support for a -V command-line option, which displays various
  compile-time settings.
- Bug 2455 - Allow fine-tuning of how often mod_xfer updates the scoreboard.
  This adds an --enable-scoreboard-updates configure option.
- Bug 2389 - 64-bit compilation warnings.
- Bug 2468 - Ability to disable address/port collision checking.  A new
  command-line option, -N, can be used to disable proftpd's checks for
  <VirtualHost> address/port collisions.
- Bug 2488 - Wrong order of privs calls on HP generates "unable to setregid()"
  error (Bug #2317 revisited).
- Bug 2392 - mod_sql needs better handling of its backend modules.
- Daniel Weuthen <dw@megabit.net> contributed a SuSE-specific init.d script
  for ProFTPD.
- Bug 2485 - SQL backend modules close all open connections too early.
  This fixes a bug where a "signal 11" would be reported, when a session
  ends, if the "EXIT" SQLLog command was configured.
- New mod_ldap version 2.8.13
- Bug 2490 - <Limit ALL> affects PORT command.  When the EPRT, EPSV, PASV,
  and PORT commands became <Limit>able (see Bug #2086), they became
  affected by <Limit ALL> as well, which breaks older configurations.
  Using the following configuration:

    <Limit PORT PASV>
      AllowAll
    </Limit>

  is a way to workaround this bug in 1.2.10 installations.
- Bug 2492 - Off-by-one error in FreeBSD PAM username length check.
- Bug 2496 - NLST off-by-one bug when handling relative paths in a chrooted
  session.
- Bug 2494 - ABOR problem with Cisco routers copy ftp flash.
- Bug 2499 - make_cmd() does not NULL-terminate cmd->argv[].
- Bug 2497 - Users can login without password if pam_start() fails.
- Bug 2273 - Ability to limit number of unauthenticated clients from a single
  host.  There is a new MaxConnectionsPerHost directive for configuring
  the maximum number of connections from a single host at the same time.
- Bug 1965 - Change timing of handling of QUIT command.  The actual ending
  of the session is now done by LOG_CMD/LOG_CMD_ERR handlers for the QUIT
  command.  This allows modules that wish to do POST_CMD processing of
  QUIT, like mod_sql, a chance to see the command.
- Bug 2484 - Better ftptop formatting.
- Bug 2071 - Add Variables API.
- Added DSO support.  See the README.DSO file for more information.
- Bug 2509 - sendfile() usage fails with > 2GB files.
- Bug 2480 - Remote users discovery. Leon Juranic described an information
  leak via timing differences in the handling of the USER command for
  valid versus invalid users.  The mod_delay module was added to address
  this timing difference.  See doc/modules/mod_delay.html for details.
- Bug 2518 - Ability to log SSL/TLS commands in an ExtendedLog.  A
  new "SEC" logging class has been added for use in ExtendedLog directives,
  e.g 'ExtendedLog /path/to/rfc2228.log SEC'.
- Bug 2507 - Enable use of sendfile by default.  Use the new UseSendfile
  directive to disable, e.g. 'UseSendfile off'.
- Bug 2471 - Restart command (REST) is not working correctly for text files.
  When in ASCII mode, ProFTPD now refuses to handle REST.  This behavior
  is documented in doc/howto/ASCII.html.
- Bug 2454 - Extend <VirtualHost> to honor multiple addresses.  With this
  change, the Bind directive is now deprecated.  See the RELEASE_NOTES
  for more details.
- Bug 2516 - Getting "421 Login Timeout" immediately upon connect.
- Bug 2520 - Turning on AuthAliasOnly disables MaxClientsPerHost.
- Bug 2510 - Use of ExportCertData TLSOption leads to segfault.
- Bug 2528 - Incorrect username 'and' parsing in AllowUser.
- Bug 2170 - Add byte count variables, similar to the file count Display
  variables.  The added variable names are:

     %{total_bytes_in}
     %{total_bytes_out}
     %{total_bytes_xfer}

  In addition, variables of a similar syntax can be used for display
  file counts, instead of the already-existing variables:

     %{total_files_in}
     %{total_files_out}
     %{total_files_xfer}

- Bug 2027 - Add log message for timed out passive transfers.
- Bug 2406 - Add a SQLEngine directive.  See the mod_sql documentation
  for details.
- Bug 2229 - NLST and LIST behave differently e.g. when listing an empty
  directory.
- Bug 2534 - Add suport for -S ListOption, for sorting files by file size.
- Bug 2536 - mod_ifsession does not properly merge in all directives.
- Bug 2540 - Fails to disable mod_delay if no DelayTable file exists.
- Bug 2541 - <Directory ~user> path resolved at startup time, rather than at
  session time.
- Bug 2549 - Allow contrib modules to be built from multiple source files.
- Bug 1651 - Add contrib module to limit connection acceptance based on system
  load.  mod_load is now one of the provided contrib/ modules.
- Bug 2503 - Bundled libcap library does not compile on IA64 machine.
- Bug 2556 - Rename of directory across devices fails.  The solution is to
  prevent renaming of directories.  Proper support for copying of directories
  will require module support.
- Bug 2563 - Linking fails on Solaris with libz and libmysqlclient.  The
  linker in question was Solaris ld, not GNU ld; the Solaris linker is
  more particular about the order of specified libraries.  GNU ld is
  less strict.
- Bug 2331 - ProFTPD should honor POSIX ACLs.  Please read the README.facl
  file for more information on POSIX ACL support in ProFTPD.
- Bug 2573 - TLSProtocol directive in proftpd.conf is ignored.  By fixing
  this bug, sites may find that a mod_tls configuration which worked
  prior to 1.3.0rc1 now does not work, failing with an error like
  "wrong version number" appearing in the TLSLog.  To restore the previous
  behavior, these sites can use "TLSProtocol SSLv23" in proftpd.conf.
- Bug 2559 - IPv6 socket option should be set for ServerType inetd.
- Bug 2164 - Support non-PASS response codes (i.e. 232).
- Bug 2515 - mod_quotatab should enforce hard limits at the filesystem level.
- Bug 2567 - Segmentation fault with 64-bit binary due to structure layout
  difference.
- Bug 2551 - Recursive LIST with symlinked directories gives duplicate results.
- Bug 2576 - PWD command does not handle " character properly.
- Bug 2493 - mod_tls should support CCC command.
- Bug 2580 - ProFTPD on Tru64 with SIA allows login with blank password.
- Bug 2554 - mod_delay gets segfault-signal on several logins.

1.2.10 - Released 04-Sep-2004
--------------------------------
- Bug 2440 - Unable to use PAM authentication properly.  Use a "*" after
  the module name in an AuthOrder directive to indicate that an auth
  module is authoritative.
- Bug 2441 - AIX5 portability bug with mod_auth_unix, mod_auth_file.
- Bug 2442 - Segfault in FreeBSD PAM library with long login names.
- Bug 2445 - AuthUserFile in <Global> context overrides <VirtualHost> setting.
- Bug 2444 - Use of sendfile() does not interoperate well with RFC2228
  security mechanisms.  Using sendfile(2) to send data bypasses the handling
  of the data by RFC2228 security mechanisms (such as those provided by
  mod_tls).  So if security mechanisms are detected, do not use sendfile().
- Scrub the ScoreboardFile for stale sessions in inetd mode.
- Bug 2427 - proftpd gets a memory fault when run from ssh batch mode.

1.2.10rc3 - Released 13-Jul-2004
--------------------------------
- Fixed typo that prevented 1.2.10rc2 from compiling.

1.2.10rc2 - Released 13-Jul-2004
---------------------------------
- Bug 2396 - NLST command doesn't understand options.  This was caused by
  the solution for Bug 2322.  However, it is not a popular solution, so
  NLST will once again handle options, but only the relevant options.
- Bug 2034 - Add support for a "graceful shutdown" signal. See
  contrib/mod_ctrls_admin.html#shutdown for details.
- Bug 2400 - <Class> search order is wrong.  The documentation correctly
  stated that <Class> sections are matched in order of definition, but the
  code has the match order in the reverse order of definition.
- Bug 2401 - MaxClientsPerClass only checks first directive in config file.
- Bug 2399 - Rename start/stop control actions to up/down.
- Bug 2082 - Add mod_rewrite "replaceall" builtin function.  See the
  RewriteMap documentation for more details.
- Bug 2403 - Sending SIGHUP to proftpd stops it when using Classes.  The fix
  for Bug #2400 could result in an infinite loop during a SIGHUP.
- Bug 2405 - "LIST *" should not list dotfiles.
- Bug 2366 - Add support for -h LIST option.
- Bug 2332 - SO_OOBINLINE error after upgrading proftpd from 1.2.6 to 1.2.9.
  This is due mostly to a change in the logging; a check for error values
  and logging of them was added.  The setting of this particular socket option
  has been moved earlier in the session, as it was found that short-lived
  TCP connections, as from monitoring systems, would cause this error.
- Bug 2407 - mod_auth_file does not allow for proper cascading of "end" and
  "set" auth requests.
- Bug 2410 - CreateHome always copies skel directory.
- Bug 2336 - Use of /dev/log on Solaris leads to kernel memory leak.
  ProFTPD's use of the /dev/log device on Solaris was tickling a Solaris
  kernel bug that caused the Solaris kernel to leak memory.
- Added a TimeoutLinger directive to complement the --enable-timeout-linger
  configure option.
- Bug 2125 - -vv command line switch should list versions of modules.
- Bug 2420 - Name field is not escaped before querying database.
  The mod_quotatab module was not properly escaping the name string it
  used when looking up records from SQL databases.
- Bug 2424 - SQLDefaultHomedir overrides column value.
- Bug 2411 - Caching effects cause RNTO to fail if AllowOverwrite is off and
  target path does not exist.
- Bug 2422 - %v not working in SQLNamedQuery.
- Bug 2418 - chmod returns 550 with filename containing multiple spaces.
- Bug 2431 - mod_sql does not use UID/GID properly in cache lookups.
- Bug 2303 - Problem evaluating multiple <Class> rules.
- Bug 2419 - Ability to disable TLSRequired on per-user basis (e.g. for
  anonymous logins).
- Bug 2438 - Display variable %z not expanded properly.
- Bug 2439 - <Limit CWD> doesn't work.

1.2.10rc1 - Released 28-Apr-2004
---------------------------------
- Bug 2135 - Add ability to handle passphrase-protected server keys.  mod_tls
  can now properly prompt for passphrases for protected server certificate
  keys when the daemon is starting up.
- Bug 2086 - Add limits for PORT, PASV.  This means that now one can use
  <Limit> to place access controls on the PORT and PASV commands.  This
  applies to the EPRT and EPSV commands as well.
- Bug 2174 - mod_auth_unix should not act authoritatively.  This was causing
  problems when using mod_auth_unix.c and the AuthOrder configuration
  directive.
- Bug 2098 - Added SetEnv and UnsetEnv configuration directives.
- Bug 2271 - Improper autoconf check for getaddrinfo() on Tru64 UNIX 5.1.
  The getaddrinfo symbol is a macro, not a function, on that platform.
- Bug 2255 - RADIUS Service-Type should reflect attribute expectations.
- Added Event API.
- Bug 2272 - Address/port collision check needs to handle DefaultAddress.
- Bug 2072 - Add Controls API.
  This API includes a new program, ftpdctl, that is used to communicate
  directly with the proftpd daemon via a new core module, mod_ctrls.  For
  this new functionality to be used, proftpd must be configured using the
  added --enable-ctrls option.
- Bug 2015 - Add AND, OR keywords to Allow/DenyUser directives.
  The AllowUser, DenyUser, AllowGroup, and DenyGroup directives now take
  an optional keyword that indicates what type of expression they are:
  AND, OR, or regex.  By default, AllowUser and DenyUser are OR expressions,
  and AllowGroup and DenyGroup are AND expressions.  For example:

    AllowUser regex ^ftp
    DenyUser AND dave,bob
    AllowGroup OR web,doc

  These demonstrate that the optional keyword modifier must be the first
  parameter in the configuration directive.
- Bug 2046 - Change RFNR and RNTO logging class to WRITE.  This means that
  ExtendedLogs that use the WRITE logging class will now include the
  RNFR and RNTO commands.
- Mac OS X 10.3 portability fixes.
- Bug 2274 - Default server only binds to one IP address of host if
  the --enable-ipv6 configure option is used.  ProFTPD will now properly
  bind to all addresses for the default "server config" server.
- Bug 2048 - Add ability to get configuration file values from environment.
  For example, you can now have the following in your proftpd.conf:

    DefaultAddress %{env:PR_DEFAULT_ADDR}

  which indicates to ProFTPD's configuration parser to get the value of
  the PR_DEFAULT_ADDR environment variable, and substitute it in, e.g.:

    PR_DEFAULT_ADDR=1.2.3.4 ./proftpd ...

  If the indicated environment variable is not present, the value is
  substituted with the empty string.
- Bug 1635 - Older systems' chown(1) does not support -h option.  The solution
  is to prevent this error from stopping the 'make install' process, as it
  is a harmless error on such systems.
- Bug 2290 - gmtime() static storage may be overwritten by modules.
- Bug 2288 - ServerFQDN set to 255.255.255.255 and not hostname.
- Added mod_quotatab to the contrib area.
- Bug 2300 - poll() returns 1 and read returns 0, resulting in an infinite
  loop.  The actual bug was caused by a goto that was being inappropriately
  used; a return value was not being checked to see if it was an error value.
- Bug 2305 - Compile Problems since > 1.2.9
  Fix the build under Solaris - ftpdctl needs to be linked against libsocket
  and libnsl.
- Bug 2267 - Broken IP subnet matching. Added new ACL parsing/matching code.
- Bug 2307 - MySQL 4.1.1 API change causes mod_sql_mysql compilation failure.
- Bug 2319 - Build scripts have owner-only execute permission.  This was
  causing problems whenever a user other than the owner of the files
  attempted to build proftpd.
- Bug 2320 - autoconf check for socklen_t doesn't work on FreeBSD 4.8-RELEASE.
  The fix is to include <sys/types.h>, if present, sooner in the check.
- Bug 1925 - Clean up of Class code.  The Class and Classes directives are
  now deprecated.  See README.classes for more details.
- Bug 2295 - mod_tls returns multiline response to AUTH commands.
- Bug 2322 - NLST -a returns listing formatted for LIST -a.  RFC959 does not
  explicitly allow dash-style options for LIST or NLST, although many clients
  attempt to use them.  De facto FTP server behaviors handle options for LIST;
  options for NLST will be explicitly rejected.
- Bug 2315 - Overlapping virtual server causes error.  If a <VirtualHost>
  was configured to handle the same IP address and port as the "server config"
  server, the wrong server configuration was being removed.
- Bug 2324 - Directories whose names contain whitespace are inaccessible.
- Bug 2306 - ftpcount output should handle case of no users.  When no clients
  are connected, ftpcount now displays "0 users".
- Bug 2337 - TLSRenegotiate parameters not processed correctly.
- Bug 2340 - Problem with parallel builds.  Proper dependencies added when
  building ftpwho and ftptop.
- Bug 2327 - SQLNegativeCache causes unnecessary errors in server logging.
- Bug 2237 - HiddenStores does not check for existing file in edge case.
- Bug 2171 - Add delete options to ftpasswd.  The ftpasswd script now
  supports the --delete-user and --delete-group options.
- Bug 2105 - Remove Authoritative directives.  The AuthPAMAuthoritative
  directive, and the "*" syntax of SQLAuthenticate, have been deprecated.
- Bug 1696 - Include directive should support directories.  The Include
  directive now functions just like Apache's Include directive, including
  handling glob characters.
- Bug 2311 - MaxClients counts unauthenticated users.  According to the
  documentation, the MaxClients configuration directive should only count
  authenticated clients.
- Bug 2339 - STAT command doesn't follow RFC959.  Previously, ProFTPD did
  not support use of the STAT command during file transfers.  This
  functionality is now implemented.  Sites wishing to prevent this can
  limit use of the STAT command by using <Limit STAT>.
- Bug 2257 - Add SITE SYMLINK command to mod_site.  Rather than adding
  this command to the mod_site module, a new module, mod_site_misc, has
  been added to the contrib area.  The mod_site_misc module implements
  SITE SYMLINK, and a few other SITE commands.  See contrib/mod_site_misc.html
  for details.
- Bug 2355 - Send error message to client when 'TLSRequired on' is in effect.
  Previously, if SSL/TLS was configured to be required for both control
  and data channels, if the client did not perform the SSL/TLS handshake for
  a data transfer, the connection would hang.  Now, an error message is sent
  to the client if no handshake is done.
- Bug 2353 - REST doesn't handle offsets greater than 2 GB.
- Bug 2357 - ftptop should use COLS for determining display width.
- Bug 2321 - FTP permission checks inconsistent for DELE and RMD/XRMD when
  symlink is in directory path.  This bug affected the RNFR command as well.
- Bug 2361 - Second USER command causes problems with chrooted session.
- Bug 2363 - ABOR response RFC 959 compliance.  The 226 response was being
  sent before closing the data connection; RFC 959 implies that the data
  connection is closed first.
- Bug 2369 - EPSV should not send network address when MasqueradeAddress is
  used.  RFC 2428 does not address the case where a server may wish to
  return an address in the EPSV response that differs from the control
  connection address, as is done in a PASV response for forwarding devices
  (e.g. NAT, firewall).  Until the proper behavior can be determined,
  do not honor MasqueradeAddress for EPSV.
- Bug 2367 - LIST *.* strange behaviour.  The builtin listing mechanism
  was inadvertently recursing into globbed directories when recursion was
  not actually requested.
- Bug 2371 - ftpasswd should have option to compare password against value
  in passwd file.  ftpasswd now supports a --not-previous-password option.
- Added a `howto' directory under `doc/', for mini-HOWTOs.
- Bug 2221 - proftpd on hp-ux 11.22.  The default data type of socklen_t
  on HP-UX 11 is problematic; many system calls expect an int, and the
  default type is a size_t.  This mismatch causes problems for 64-bit
  builds.
- Bug 2385 - Renames fail with error "Invalid cross-device link".
- Bug 2383 - mod_ctrls.c: ctrls_listen(): Invalid size in bind() argument.
  The size of struct sockaddr_un is not consistent across platforms.
- Bug 2387 - PRIVS_USER macro should set effective GID to user's primary GID.
- Added a `modules/' directory under `doc/', for core module documentation.
  Currently there are HTML docs for mod_auth_file, mod_cap, and mod_ctrls.
- Bug 2317 - Wrong order of privs calls on HP generates "unable to setregid()"
  error.

1.2.9 - Released 31-Oct-2003
---------------------------------
- Bug 2181 - The prior fix for Bug#2181, handling of the PORT command when the
  --enable-ipv6 configure option is used, was not quite correct.  A problem
  still existed when an IPv4 client used the PORT command when talking to
  an IPv4-only vhost (as opposed to an IPv4 and IPv6 vhost).  Now PORT is
  properly handled in all cases.
- Bug 2204 - On systems that use the gethostbyname2() function, IPv4 clients
  were not being properly resolved to their DNS names.
- Bug 2242 - proftpd reread included additional config as user nobody instead
  of root.  The bug was caused by configuration directive handlers
  (specifically, SyslogFacility and SystemLog) that would incorrectly change
  the process privileges; depending on the order of configuration in
  proftpd.conf, some Included files might not be parseable due to permissions
  problems.
- Bug 2197 - The RPM .spec has been updated for easy RPM builds from CVS
  snapshots.
- Check for excessive length of symlink directory listing entries (submitted
  by Michael Hendrickx <michael@scanit.be>)
- Two memory leaks, seen mostly during recursive directory listings, have
  been fixed.

1.2.9rc3 - Released 15-Oct-2003
---------------------------------
- Bug 2167 - getnameinfo() on FreeBSD doesn't support IP address lookups.
- Bug 2176 - getnameinfo() error on Cygwin during startup.
  The sa_family member of the address was not being properly initialized
  in some instances.
- Bug 2179 - ROOT_UID instead of ROOT_GID used in setegid() call.
  This affects Cygwin installations.
- Fixed ASCII file remote exploit discovered by X-Force at ISS:
    http://xforce.iss.net/xforce/alerts/id/154
- Bug 2181 - IPv4 active transfers don't work when using --enable-ipv6.
  IPv4-mapped IPv6 addresses were not being properly compared for active
  data transfers.
- Bug 2200 - Correct segfaults with xlate_ascii_write() on IRIX.
- Bug 2024 - DefaultServer not functioning properly.
  The addition of the Bindings API in 1.2.8rc1 inadvertently caused the
  DefaultServer directive to not be properly honored in some configurations.
- Bug 2183 - Directory configuration lookups broken in 1.2.9rc2 (same as
  Bug 2165).
- Bug 2191 - Segfault in mod_sql_mysql when using 'Backend' SQLAuthType.
  This happens only with MySQL 4.1.  In MySQL 4.1, the way in which MySQL
  handles its passwords changed, and mod_sql_mysql was using the new
  interface incorrectly.
- Bug 2202 - AllowLogSymlinks check is flawed.
  Calling open(2) on a path that is a symlink will follow that symlink;
  the AllowLogSymlink check assumed that open() did not follow the symlink.
  The fix is to use the O_NOFOLLOW flag when opening log file paths.  However,
  this flag does not exist on Solaris machines, and so there still exists
  a race condition on Solaris when checking that a log path is not a symlink.
- Bug 2188 - Wildcard sockets not properly handled on FreeBSD.
  Similar to bugs 2167, the sin_len/sin6_len members of socket structures
  were not being properly set for wildcard sockets.
- Bug 2204 - Reverse DNS lookups not happening properly on connected clients
  on FreeBSD.  The gethostbyname2() function needs to be used on FreeBSD.
- Bug 2222 - Overlapping vhosts should warn instead of die.
  Prior to 1.2.9rc1, it was possible to have multiple vhosts configured that
  resolved to the same IP address/port combination.  This typically occurs
  when DNS names are used, and different DNS names resolve to the same IP
  address.  In 1.2.9rc1, these collisions are scanned for, and such collisions
  are treated as a fatal error.  With this change, such colliding vhosts
  are handled similar to vhosts that have unresolvable names: they are
  logged, then removed from the in-memory list of vhosts.

1.2.9rc2 - Released 11-Sep-2003
---------------------------------
- Bug 2051 - freebytes in TransferRate does not work properly.
- Bug 2043 - Proftpd converts LF to CRLF on PUT on Cygwin.  This turned out
  to be caused by the Cygwin layer.  The fix was to use the Cygwin-specific
  O_BINARY open() flag when opening binary files on Cygwin.
- Bug 1804 - Permit selection of additional contrib modules when building
  the RPM
- Bug 2074 - MaxStoreFileSize restriction capabilities ignored.  This bug
  was affecting MaxRetrieveFileSize as well.
- Bug 2075 - LIST / fails under Cygwin.  This was due to the addition of
  an additional path separator character; Cygwin treats paths that start
  with "//" differently than paths that start with "/".
- Bug 2076 - The --enable-transfer-buffer-size configure option doesn't work
  properly.  It was overriding the --enable-buffer-size option, rather than
  the corresponding tunable buffer size.
- Bug 2069 - Long MKD path causes truncated server response.
- Fixed handling of %N/%y in DisplayConnect files.
- Bug 2083 - "550 Access denied" on group permission with AuthGroupFile.  This
  was caused by a strictly linear search in the AuthGroupFile from the
  current file pointer to end of file, which (depending on the ordering of
  entries in the file) might have skipped necessary group entries.
- Bug 2088 - proftpd -t segfault.  A very specific configuration would cause
  a segfault in the configuration parser: if the first sub-context in a given
  context (e.g. a <Limit> context within a <Directory> context) was empty,
  the removal of that empty context from the internal structures by the
  parser would inadvertently trigger a segfault later.  This has been
  fixed by using a better memory pool, with a longer lifetime, for allocating
  the internal configuration structures.
- Bug 2090 - mod_rewrite doesn't compile on Solaris 8.  The FIONREAD macro
  was undefined, due to a strange necessity in the Solaris system headers
  for a missing flag.
- Bug 2100 - Invalid domain in <VirtualHost> tag causes segmentation fault.
- Fixed handling of mod_tls' TLSCertificateChainFile directive.
- Bug 2103 - AuthAliasOnly in server context causes hang.
- Bug 2110 - Segfault if gethostname(2) returns NULL.
- Bug 2113 - mod_sql default uses mysql keyword "password".  The default
  has been changed to "passwd".
- Bug 2115 - ftptop depends on snprintf but doesn't link in lib/libsupp.a
  on snprintf-less platforms
- Corrected handling of mod_tls' TLSCACertificateFile and TLSCACertificatePath
  directives so that they are properly allowed in <VirtualHost> and <Global>
  contexts.
- Bug 2119 - FEAT response format does not conform to RFC2389.  Extraneous
  leading whitespace removed.
- Fixed file descriptor leaks that occur if mod_tls encounters errors when
  handling CA certificate files.
- Bug 2118 - mod_sql's %F doesn't work for DELE command; %f is inconsistent.
  mod_sql's handling of cookies is now updated to match mod_log.
- Bug 1711 - IPv6 support.  Support for EPRT and EPSV added.  To enable IPv6
  support, use the new --enable-ipv6 configure option.
- Bug 2130 - %y in DisplayLogin is not updated correctly.
- Bug 2137 - NLST and IgnoreHidden causes segfault.
- Bug 2142 - sstrncpy() not available to lib/vsnprintf.c.  sstrncpy() is now
  implemented in the support library (libsupp.a).
- Bug 2144 - Rework autoconf handling of --enable-sia option.
- Bug 2147 - Segmentation fault processing file in ASCII mode.
- Fixed mod_ifsession's handling of multiple configuration sets.
- Bug 2148 - Enforce PR_TUNABLE_LOGIN_MAX.
- Bug 2141 - Glob Allow/Deny parameters cause extraneous log messages when
  comparing addresses.
- Bug 1804 - RPM spec file improvements
  The spec file now has xinetd support, builds under newer version of RPM,
  installs standalone support with the main proftpd RPM, and accepts --with
  mod_modname arguments during the build process.
- Bug 2127 - Entry in the file section
  The RPM spec's %files section now honors the install prefix.
- Bug 2108 - IgnoreHidden should not hide dotfiles
  Dotfiles are now displayed when the -a argument is supplied, even when the
  IgnoreHidden directive is enabled. To replicate the old behavior of hiding
  dotfiles no matter what, use either of the following directives:
    ListOptions "" strict
    HideFiles ^\..*
- Bug 2146 - DNS names not handled properly when --enable-ipv6 is used
  DNS names with both A and AAAA records were not being properly handled;
  listening sockets for both the IPv4 and IPv6 addresses were not being
  established.
- Bug 2007 - autoconf header detection problem.
  On FreeBSD and other platforms, changes in autoconf require that headers
  be included in the proper order during configure's check.
- Bug 2153 - Small error in handling PR_AUTH_RFC2228 authentication code
- Bug 2154 - SQL query loses shell information.
  An index was not being properly incremented in some cases when retrieving
  user information.
- Bug 2161 - Duplicate autoconf check for sia.h.
- Bug 2122 - EAGAIN on Solaris can cause an infinite loop.
  Under certain conditions, when reading from a descriptor on Solaris,
  EAGAIN can be returned, which proftpd did not handle properly.

1.2.9rc1 - Released 15-May-2003
---------------------------------
- Bug 1828 - mod_sql can only find mysql.sock if in /tmp.  This was caused
  by the fact that mod_sql_mysql did not load/read the MySQL .cnf
  configuration files.  Now, when starting, mod_sql_mysql will read .cnf
  files for "client" sections.
- Bug 1960 - Add removed file size by DELE command to xferlog.
- Bug 1967 - Add display of uptime to ftpwho, ftptop.
- Added AnonRejectPasswords directive.
- Added ftpshut -R command-line option, for deleting the ftpshut shutdown
  file.
- Bug 1972 - %T not correctly shows time at performance of a command "rename".
  This was due to improper use of uninitialized data.
- Bug 1794 - Scoreboard format changes.
- Bug 1979 - Add TLSTimeoutHandshake directive.  This adds a directive to
  configure a timer when SSL/TLS handshakes are occurring, to prevent
  a malicious client from attempting to DOS a TLS-enabled server.  The default
  timeout is 5 minutes.
- Bug 1869 - Add option "-S/--server" to ftpcount, ftptop, ftpwho.  This
  option can be used to specify a ServerName; the utilities will then
  display information for that specific server.
- Bug 1980 - Login with incorrect password possible when using mod_radius.
  This was caused by the retaining of the OK state when a user authenticated
  via RADIUS, but the login process later fails (e.g. home directory
  inaccessible or something similar); subsequent logging in as a different
  user would succeed because the OK flag was not cleared.
- Added contrib module mod_ifsession-0.9rc6.
- Bug 1932 - Make Max* checks a PASS POST_CMD handler.  One of the consequences
  of this change is that the Max* limits will always be enforced after the
  PASS command has been sent, not after the USER command (as used to be done).
  Also, MaxHostsPerUser and MaxClientsPerUser limits will be determined using
  the locally resolved username, not using any user aliases.
- ProFTPD now checks for IP address/port collisions in the configuration
  file, and will refuse to start unless all configured server contexts
  have unique IP address/port combinations.
- Bug 1969 - Add scoreboard-scrubbing timer.  The scoreboard will be scanned
  now every 30 seconds for entries with invalid PIDs; this timer can be
  adjusted using the PR_TUNABLE_SCOREBOARD_SCRUB_TIMER #define.
- Bug 1921 - Socket-level performance tweaks.  This change deprecates the
  tcpReceiveWindow and tcpSendWindow configuration directives, replacing
  them with a single SocketOptions configuration directive.  This new
  directive can be used to tune the TCP send and receive window sizes as well
  as the TCP max segment size.  A new configure option,
  --enable-transfer-buffer-size, is also added, to be used for tuning the
  size of internal buffers used for file transfers.  Using this option to
  configure an 8K buffer size often results in higher transfer speeds.
- Bug 1849 - Compile can have trouble finding mysql.h.  The MySQL backend
  module was assuming that mysql.h would be found in a directory named
  "mysql"; for some distributions this is not the case.  Similarly for
  the Postgres backend module and the libpq-fe.h file.  Users may need to
  alter the --with-includes configure option used when building mod_sql.
- Bug 1915 - Unsafe pointer usage in scoreboard file format.
- Bug 1983 - Filenames beginning with '#' fail to upload/download.
- Bug 1985 - mod_rewrite fails to build on platforms without flock().
- Bug 1730 - mod_sql_mysql logging of long transfers fails.  This turned out
  to be caused by the default MySQL timeouts on non-interactive sessions
  (8 hours).  The fix involves marking mod_sql_mysql sessions as interactive;
  this means that users may use the 'interactive-timeout' option in their
  .cnf files to override the default interactive session timeout (also 8 hours).
- Bug 1989 - SQLLog '*' doesn't match any commands.
- Bug 1986 - mod_rewrite backreferences not zero-based (use $1 not $0?). The
  bug here turned out to be an off-by-one offset; mod_rewrite was starting
  at 1 when examining matched groups, rather than 0.  Most of the time $0 will
  not be what is desired, however, for $0 refers to the original string being
  matched.
- Bug 1987 - mod_rewrite seems not to handle more than one backreference.
- By default, mod_tls will now turn manually turn RSA blinding on, when
  OpenSSL older than 0.9.7b is used, in order to thwart certain timing attacks
  possible against RSA operations. The following URL contains more information:
  http://www.openssl.org/news/secadv_20030317.txt
- Bug 1995 - incorrect handling of curses/ncurses header and libraries in
  ftptop
- New mod_radius directives: RadiusGroupInfo, RadiusVendor.  mod_radius
  now looks for custom response information in Vendor-Specific Attributes
  (VSAs) rather than the normal RADIUS attributes; VSAs are more flexible.
- Fixed a bug with mod_tls' use of SSL_shutdown(), to prevent it from hanging
  when interacting with some buggy FTPS clients (e.g FlashFXP, SmartFTP)
- Bug 1935 - mod_ls memory leak.  When a recursive directory listing is
  requested (and allowed), proftpd would use its memory pool system,
  allocating memory for every file to be listed.  For large/deep directory
  structures, this memory usage could grow quite large.  And, due to the
  way in which the underlying memory allocator (the C library, usually)
  works, that memory is never really released back to the operating system.
  This means that tools like ps and top reporting a never-shrinking memory
  footprint for the process.  To help alleviate this, proftpd has been
  altered to use malloc/realloc when providing recursive directory listings,
  making the memory footprint a little smaller.  The caching behavior of
  the underlying memory allocator cannot be changed, though.
- Bug 1997 - UnixWare 7.1.3 & port 20.
- Bug 1998 - Add ListOptions for setting limits on -R listings.  New
  keywords have been added to the ListOptions directive: maxdepth, maxdirs,
  and maxfiles.
- Bug 2011 - No "FTP session closed." msgs written to logfile.  This affected
  only inetd-run servers.
- Added two new configure options, --disable-curses and --disable-ncurses.
  By default, ftptop will use ncurses if available, then curses (if available).
  In some cases, both curses and ncurses may be present, and yet the admin
  would prefer ftptop to use curses.  Using the above options, one can
  disable ftptop's use of ncurses or curses, as needed.
- Bug 2016 - man pages should be autogenerated to reflect the --prefix used.
- Bug 2018 - Incorrect caching of TransferRate values.
- Bug 1813 - configure code: mistake in BSD sendfile semantic detection.
- Bug 2019 - proftpd support for Solaris 8/9 native sendfile
- Bug 2002 - Per-<Directory> PathAllowFilter/PathDenyFilter.
- Added RootRevoke directive.
- Bug 2021 - Inetd mode and scoreboard format changes.
- Bug 1532 - Human readable disk free cookie.  Display* files can now make
  use of a %f magic cookie for displaying the available disk space with
  units (i.e. KB, MB, GB, etc).  This compliments the currently available
  %F cookie, used to display the number of bytes of available space (without
  units).
- Bug 2003 - mod_auth.c does not compile for cygwin on W2K.
- Bug 2029 - Rewrite rule may execute more than once if multiple
  RewriteConditions exist.  This turned out to be caused by mod_rewrite's
  merging down of its directives, and the way in which multiple occurrences
  of directives are handled.  Now, even for merged-down mod_rewrite directives,
  a given RewriteRule will only be processed once.
- Fixed minor fd leak where listening socket descriptors were not being
  properly closed in a session process, when the session is first starting.
- Cygwin compilation/portability fixes.
- Fixed bug where AllowForeignAddress was not properly blocking "bounce"
  attacks in some cases.  Patch contributed by Patrick Hardy <kaber@trash.net>.
- Bug 2032 - AuthOrder not working when first option is mod_auth_file.c.  This
  was caused by mod_auth_file's returning of an ERROR condition, rather than
  DECLINED, when the module could not obtain the user's encrypted password
  for verification.
- Bug 2047 - 1024 or more chars in .ftpaccess causes lockup.  Certain conditions
  allowed for parsing of configuration files to enter an infinite loop.
- Bug 2031 - Add support for flags for RewriteCondition, RewriteRule
  (a la Apache's mod_rewrite).  mod_rewrite now supports various tests that
  can be used in RewriteConditions, the NC and OR flags for RewriteConditions,
  and the NC and L flags for RewriteRules.
- Bug 1977 - Add %u variable support in configuration file.  With this feature,
  one can configure DefaultRoot paths such as /home/%u/public_ftp, and the
  %u variable will be expanded to the logged in user name.

1.2.8 - Released 04-Mar-2003
---------------------------------
- Bug 1863 - Unable to build under UnixWare 7
- Bug 1943 - Unable to install on FreeBSD 5.0.  FreeBSD 5.0's header files
  have been rewritten, and glibc's glob.h collided with the new files.  The
  fix was simply to use size_t, rather than trying to determine and use
  __size_t (glob.h was intended to be used during library compilation, not
  during application compilation).
- Bug 1950 - OSX setgrent(3) returns int, causing compiler warning.  Unlike
  most other Unix flavours (but like FreeBSD), OSX's setgrent(3) returns
  int, rather than void.  A configure check was written to test for this. 
- Bug 1949 - Compiler warns of 'long double' usage on OSX.  Typecasts have
  been added to quell some warnings, and an autoconf check added for compiler
  support for -Wno-long-double to quell others.
- Bug 1952 - Umask Bug: Server Not Honoring VirtualHost Umask.  This was
  a statcache caching effect bug.
- Bug 1916 - Transfers hang with strange transfertime in logfile.  This
  appears to have been due to use of an uninitialized value.
- Bug 1948 - mod_xfer relinquishes privs before chmod takes place.  In
  places where UserOwner is used to "give away" files, the chmod() attempt
  that follows the chown() (used to preserve permissions sometimes altered
  by the operating system's chown(2) call) did not use root privs, and thus
  the client did not have permission to write the file.
- Added FTPS FEAT responses, as per Section 5 of the FTPS Draft.
- Bug 1956 - Upload transfer rate broken.  The wrong variable was being used.
- Bug 1941 - SCO OpenServer 5.0.5 issues.  Fixing this bug required adding
  more autoconf portability checks.
- Bug 1958 - ftpwho -o oneline has newlines when client is idle.
- Bug 1908 - ExtendedLog to work properly again in <Anonymous> context.
- Bug 1966 - SCO OpenServer 5.0.5 and inetd.
- Bug 1953 - STAT -R does not work.  There were some variable initialization
  issues in the handling of options for the STAT command.
- Bug 1970 - Transfer time wraps around and causes problems with transfer
  speed calculation.  This was a reporting problem, mostly.  An internal
  variable was storing time in microseconds; now using milliseconds.
- Bug 1937 - Transfer hangs when using TransferRate limits on a resumed
  download.  This turned out to be a misuse of the resumed file position
  when calculating the TransferRate.
- Bug 1964 - When uploading to an NFS mounted file system in passive mode
  read() get EAGAIN and closes connection.  This turned out to be caused
  by control messages in the STREAMS device (and thus relevant only to
  systems that use STREAMS).
- Portability fixes for FreeBSD-5.0.
- Bug 1976 - Login hangs, spawned process runs in endless loop in mod_auth.
  This was caused by a combination of "AuthAliasOnly on" and UserAlias
  directives in which the alias and the username were identical.  Different
  alias and username in a UserAlias directive is now required.

1.2.8rc2 - Released 29-Jan-2003
---------------------------------
- Bug 1894 - Double chdir into self-referencing symlink fails with
  "No such file or directory".  The errno value has been changed from
   ENOENT to ELOOP.
- Bug 1272 - Requested Addition: DenyFilter by User or DenyFilter by Directory.
  AllowFilter and DenyFilter are now extended to <Directory> and .ftpaccess
  contexts.
- Bug 1671 - new directive SQLLogFile.
- mod_linuxprivs has been renamed to mod_cap and is now built into ProFTPD
  by default if the host OS (Linux) supports it. autoconf detection code
  based on a submission by Mihai RUSU <dizzy@roedu.net>.  The mod_cap
  directives are CapabilitiesEngine and CapabilitiesSet.
- Bug 1893 - Apple likes to move things. PAM support works on OS X again.
  Submitted by: thesin@users.sourceforge.net (Justin F. Hallett)
- Bug 1826 - Makefiles are a bit icky
- Bug 1904 - Tru64 UNIX 4.0D and sstrncpy()
- Bug 1891 - SGI syslog isn't being written to.  Turns out that /dev/log on
  SGI is a STREAMS device, just as for Solaris.  The fix for this bug works
  for IRIX6; earlier versions of IRIX may still see this bug.
- Bug 1919 - <Directory> section already configured for $dir needs
  clarification.  This has been resolved by adding a debug statement (level 2)
  to the <Directory> handler that reports on the given/resolved paths used.
- Bug 1910 - ProFTPD hangs on SIGHUP.  This was triggered by mixing stdio
  and regular I/O library calls related to password and group entries.
- Add -Wundef and -Wfloat-equal to CFLAGS (Suggested by Steve Grubb
  <linux_4ever@yahoo.com>)
- Fixed broken tcpReceiveWindow and tcpSendWindow configuration directives.
  The setsockopt(2) function was being called at the wrong time during the
  establishment of the data connection.
- %f for DELE commands was not being properly expanded.
- Bug 1923 - %N magic cookie reports incorrectly.  This was an off-by-one
  bug.
- %L was reporting the remote IP address, rather than the local IP address.
- Bug 1922 - Server allows RNTO an existing file even with AllowOverwrite
  turned off.  Now, RNTOs to existing files are denied unless AllowOverwrite
  is on.
- ftptop now displays transfer rates in it's "transfer speed" display mode.
  Use the 't' key to toggle between ftptop display modes.
- Bug 1926 - AuthOrder doesn't work
- Bug 1918 - AuthUserFile not works normally.
- Bug 1241 - Additional functionality: HomedirOnDemand.  This has been added
  as a new configuration directive, CreateHome.
- Bug 1734 - Cygwin - Unable to set uid
- Bug 1938 - upload to root directory fails.  This was caused by caching
  effects.
- Bug 1939 - RLimitMemory seems broken.  The problem turned out to be bad
  handling of the case where sizes were used without specifying units.
- Bug 1911 - NLST is not being Limited in DIRS.  The issue was that directory
  paths were not being properly expanded, for purposes of looking up <Limit>s,
  in the handling of NLST.

1.2.8rc1 - Released 28-Dec-2002
---------------------------------
- Bug 1597 - Problems with HP-UX 10/11 trusted systems, mod_pam, and mod_unixpw.
- Bug 1482 - Add new %U meta to LogFormat, for logging original username.
- Bug 1683 - Handling of VirtualHosts on startup.  Now, rather than dying
  when unable to resolve a <VirtualHost> DNS hostname when starting up, the
  daemon will log the error, and skip the bad <VirtualHost>.
- Bug 1825 - AUTH macro namespace cleanup.  A "PR_" prefix has been added to
  the AUTH_* macros, to help prevent namespace collisions.  This means that
  some third-party auth modules may need to be updated.
- Bug 1806 - Add RFC2389 support.
- Bug 1833 - Add ability to have add'l module initialization callback.
- Bug 1743 - No magic cookie for number of files transfered.  New cookies
  added for Display* files: "%i" for total number of files uploaded (read "in")
  during a session, "%o" for total number of files download (written "out")
  during a session, and "%t" for total number of files transferred (both
  uploaded and downloaded).
- Bug 1653 - Complete the FS API abstraction implementation.  The Developer
  Guide will have the complete details on using this API.
- Bug 1712 - TLS support.  mod_tls-2.0.5 has been added to the distribution.
  Many, many thanks to Peter Runestig for his work on this, and for maintaining
  his code through so many versions of ProFTPD.
- Bug 1788 - Add ability to configure auth module checking order.  This is
  now configurable via the new AuthOrder directive.
- Bug 1205 - Add debug option to SystemLog.  Actually, this feature request
  has been resolved by adding a new DebugLevel configuration directive, so
  that a debugging verbosity can be set in the configuration file as well
  as on the command line.
- Added mod_rewrite to distribution.
- Bug 1403 - per-server system logs via ServerLog directive.
- Bug 1605 - MKD and RMD do not log filepaths with %f or %F option in
  ExtendedLog.
- Removing the RateRead* and RateWrite* configuration directives, and replacing
  them with a single new directive, TransferRate.
- Bug 1789 - Add ability to block recursive directory listings.  The
  LsDefaultOptions configuration directive has been deprecated in favor of
  the more feature-rich ListOptions directive.
- Added Bindings API
- Bug 1515 - Enable mod_log to log into default log / syslog.  The ExtendedLog
  directive can now take a "path" of the form: "syslog:level", where the
  "syslog:" prefix tells mod_log to log that ExtendedLog data via syslog,
  and the "level" informs mod_log of which syslog level to use.
- AIX sendfile support. Thanks to Andy Igoshin <ai@vsu.ru> for the patch.
- 1858 - move "session closed" logging from graceful quit to child exit
  sequence.  This allows for better log reporting, with respect to sessions
  ended through means such as catastrophic death of client, or segfaults.
- Added --enable-devel configure option, for enabling code of interest to
  developers
- Bug 1507 - regex pattern matching in [Allow/Deny][User/Group].  This has
  been implemented by adding a "regex" optional parameter to the AllowGroup,
  DenyGroup, AllowUser, and DenyUser directives.  The documentation will
  be adjusted accordingly.
- Bug 1882 - SITE chmod 777 file<space>name.  The patch for this works
  for filename parameters to the SITE CHGRP command as well.
- Bug 1881 - Bug in Function MaxClients.  This was caused by an off-by-one
  bug in the handling of non-anonymous settings.
- Bug 1886 - Ftpwho uses too many lines when authenticating.
- Bug 1875 - same radius packet id for start- and stop-accounting record.
- Bug 1883 - socklen_t patch. Thanks to Andy Igoshin <ai@vsu.ru> for the
  patch.
- Bug 1885 - -q/--quiet option for use with the -n/--nodaemon flag. Useful
  for running proftpd from inittab or with daemontools.
- Bug 1677 - Integrate ProFTPD with C2/SIA on Tru64 Unix.  The --enable-sia
  configure option has been added.
- Bug 1837 - Add module specifically for handling Auth*Files, providing
  finer-grained control.  The new mod_auth_file module is compiled in by
  default, and can be disabled using the --disable-auth-file configure option.
  For consistency, mod_unixpw.c has been renamed to mod_auth_unix (and now
  has a --disable-auth-unix configure option), and mod_pam.c has been renamed
  to mod_auth_pam.c (with an explicit --enable-auth-pam configure option).
- Bug 1900 - ftpwho's output on uploads.  ftpwho now reports "n/a" rather than
  "0%" on uploads, for the server does not know how large of a file is being
  uploaded in advance, and cannot determine a "percentage done" value.
- Bug 1888 - Increase mod_linuxprivs configurability.  Two new directives,
  LinuxPrivsEngine and LinuxPrivsCapabilities, are added.
- Bug 1905 - AIX needs "config.h" included before *anything* else.
- Bug 1903 - ftpwho depends on snprintf but doesn't link in lib/libsupp.a
  Primarily of issue under Solaris 2.5 and Tru64 4.0D.
- Bug 1863 - Unable to build under UnixWare 7
- Bug 1906 - Add description strings to AC_DEFINE

1.2.7 - Released 05-Dec-2002
----------------------------
- Bug 1840 - Problem with syslog default destination on HP-UX.  HPUX uses
  a default device of /dev/log.un rather than /dev/log.
- Bug 1844 - DisplayLogin %y macro is off by 1.  Consequence of scoreboarding
  code changes.
- Bug 1838 - Since 1.2.6: in add_useralias() setting flag CF_MERGEDOWN breaks
  aliased anonymous functionality.  The fix was to set the CF_MERGEDOWN flag
  only if the UserAlias directive is not being used in the <Anonymous>
  context.
- Bug 1812 - Double logging lines for ExtendedLog.  No need to merge this
  particular directive down.
- Bug 1848 - undefined reference to `halfdelay'. curses does not seem to
  provide this function, as ncurses does.  The patch works around this by
  using halfdelay() if linking against ncurses, and using nodelay() and sleep()
  if linking against curses.
- Bug 1839 - undefined reference to `get_fs_size'. Expand BSD
  statfs()/statvfs() support beyond FreeBSD.
- Bug 1680 - Error in startup script. Add /usr/local/sbin/ to the included
  rc script's $PATH
- Bug 1852 - Proftpd gets signal 11 on "quote site".  The mod_site module
  was not properly checking the number of parameters for SITE commands.
- Bug 1856 - TimesGMT acts like default is 'off'.  The default for this
  directive was inadvertently set to "off", rather than the documented default
  setting of "on".
- Bug 1853 - SyslogFacility: unable to open syslog.  This turned out to be
  due to the fact that /dev/log on Solaris (and other platforms?) is a
  STREAMS device, which requires open() and putmsg(), rather than connect()
  and send().
- 1846 - File overwrites fail.  Tracked down by Sergei Rozinov to involve
  uninitialized stack data.
- Bug 1861 - 'ftpwho -v -o oneline' print all connections in one line.  This
  bug appeared in 1.2.7rc3, a consequnce of Bug#1815.
- Bug 1868 - Wrong cmdopts in ftpcount.c.
- Added custom memory scrubber routine to deal with the issue mentioned in
  this Bugtraq thread: http://online.securityfocus.com/archive/1/298598

1.2.7rc3 - Released 15-Nov-2002
-------------------------------
- Fixed configure script detection and handling of ncurses (HAVE_LIBNCURSES
  was not being properly defined).
- Added --enable-scoreboard-buffer-size option to configure script, for
  tuning the size of some scoreboard fields (e.g. the full client command
  and the current working directory).
- Bug 1287 - Error compile with autoshadow option.  AIX does not have
  traditional shadow support, and uses other mechanisms.  This means that
  the --enable-autoshadow and --enable-shadow configure options should not
  be used when configuring proftpd for AIX.  The configure script has been
  updated to detect when these options are used on AIX, and to automatically
  disable them.
- Bug 1722 - Can't work magic cookie %F on FreeBSD.
- Make sure session.xfer uses cleared memory so unset structure members
  won't contain random values.
- Fixed handling of AuthAliasOnly, broken slightly by Bug#1567.
- Bug 1800 - Proftpd child segfaults when using a PASS without no USER first.
  mod_wrap was making a bad assumption about the USER name being available.
  This assumption has been corrected.
- Bug 1803 - Check for SIZEOF_UNSIGNED_LONG_LONG to determine LFS support
  breaks some Linux installations
- Bug 1805 - PAM support under Mac OS X
- Bug 1772 - Docs fixup in RPM spec file
- Bug 1398 - there is no log rotate for /var/log/xferlog
- Bug 1814 - class names are truncated in scoreboard entry
- ftptop can now use either curses or ncurses
- Bug 1818 - proftpd doesn't compile on hpux11
- Bug 1760 - AllowOverwrite not operational.
- Bug 1703 - mod_sql_mysql compile error.  This was eventually tracked down
  to an overlap between ProFTPD's bundled getopt implementation, and
  MySQL's bundled getopt implementation.  To prevent this problem, a new
  --without-getopt configure option has been added, which tells the ProFTPD
  build process to explicitly not use the ProFTPD bundled getopt
  implementation.
- Only link ftptop with lib{n,}curses - it isn't needed in any other
  binaries
- Bug 1815 - Patch to add class information to ftpwho (with verbose on)
- Bug 1810 - Wrong permissions assigned to uploaded file.  This turned out
  to be related to the addition of the statcache code, and its interaction
  with the UserOwner and GroupOwner configuration directives.
- Bug 1830 - MaxClientsPerHost (small) Bug.  Off-by-one error in the handling
  of the MaxClientsPerHost directive, introduced by the change in timing of
  scoreboard modifications of the new scoreboarding code.
- ftpasswd now exits with different values, depending on the problem cause.
  Thanks to Graham Dunn <gdunn@inscriber.com> for these changes.

1.2.7rc2 - Released 22-Oct-2002
-------------------------------
- Bug 1757 - non-ANSI Syntax in netio.c
- Bug 1735 - Proftpd 1.2.6 compiled on FreeBSD 4.6.2 exits on signal 11
- Bug 1759 - ftpwho shows much more connections than really is.  This bug
             only occurred for those daemons running in inetd mode.
- Bug 1769 - Lack of supplemental groups can cause segfault.  This bug is
             a result of the fix for Bug 1666.
- Bug 1770 - Forgetting to check for no IP in string.
- Moved the switching to the User/Group for a vhost up in the order, to occur
  before any modules' session initialization callback is invoked.
- Bug 1644 - LogFormat local IP and FQDN tags missing.  Added %L to LogFormat
             meta sequences for logging local server IP address, and %V for
             logging local server FQDN.
- Bug 1785 - Bad handling of symlinks.  This bug appeared as a consequence
             of Bug#1486's fix, which involved caching of struct stats in
             order to effect a speed-up of directory listings.
- Bug 1778 - 1.2.7rc1 fails to link on OpenBSD 3.2-current.  The ftptop
             utility was not properly utilizing the macro detecting the
             presence (or absence) of the ncurses library.
- Adding new configure options (see configure --help) for setting some of
  the "tunable" values in options.h via the configure command.

1.2.7rc1 - Released 01-Oct-2002
-------------------------------
- Bug 1649 - setproctitle() prepends and appends process name
- Bug 1666 - Auth modules can return duplicate supplemental groups
- Bug 1654 - Add DESTDIR in Makefile
- Bug 1682 - Broken SyslogFacility requires custom syslog code
- Bug 1076 - Toggle parsing of .ftpaccess files with a AllowOverride
- Bug 1724 - AuthPAM off does not work beginning 1.2.5
- Bug 1593 - mod_sql doesn't cache failed uid lookups
- Bug 1719 - Add RFC2228 stuff to distribution
- Bug 1663 - Add SITE CHGRP command
- Bug 1725 - disconnect when specify multiple ranges on Allow
- Bug 1253 - No ability to configure address for main server
- Bug 1432 - Pedantic handling of leading whitespace in FTP commands
- Bug 1652 - Add connection-rate limiting mechanism
- Bug 1662 - Define _GNU_SOURCE
- Bug 1486 - mod_ls is extremely slow
- Bug 1669 - Filename meta (%f) not correctly expanded for some commands
             in WRITE logging class
- Bug 1065 - New directives to limit file size on upload and download
- Bug 1658 - Separate session/daemon resource limit settings
- Bug 1436 - Feature Enhancement: Timeouts on a <Virtualhost> basis
- Bug 1737 - Enhance file hiding via regular expressions
- Bug 1736 - RETR does not handle an inappropriate REST
- Bug 1745 - multiple similar entries in extended log
- Added NetIO API
- Bug 1726 - Cygwin's Makefile inconsistency
- Bug 1713 - Scoreboard changes
- Bug 1395 - Check return values in PRIVS calls
- Bug 1732 - No checking for NULL at inet_ascii and pr_fnmatch
- Bug 1687 - Add contrib module for RADIUS authentication, accounting
- Bug 1572 - Need to use pam_end() to close session on Solaris 8
- Bug 1475 - Minor changes to SITE command handling
- Bug 1748 - SQLLog doesn't work with DELE (no filename with %f)
- Bug 1694 - SQLLog QUIT doesn't execute on connection close
- Bug 1675 - add new MaxClientsPerUser configuration option

1.2.6 - Released 04-Sep-2002
----------------------------
New mod_ldap (2.8.10)
- Fixed bug in matching of IP addresses introduced by Bug#1701

1.2.6rc2 - Released 15-Aug-2002
-------------------------------
- Bug 1681 - Fixed bug made when adding <IfDefine>, <IfModule> support
- Bug 1645 - Changed ordering of close() of HiddenStor files slightly
- Bug 1674 - Changed timing of allocation of dynamic buffer (to avoid segfaults)
             in the supplied fgetgrent() function, which is used for
             AuthGroupFiles under FreeBSD.
- Bug 1697 - Fixed memory leak involving allocated regex_t *s and SIGHUP
- Bug 1701 - Fixed/enhanced name/IP matching function by adding matching of
             ip1/ip2 to function; it was just name1/name2, name1/ip2 matching.

1.2.6rc1 - Released 02-July-2002
--------------------------------
- Bug 1407 - Removed unnecessary check for prior PORT/PASV in STOR
             PRE_CMD handler (RETR PRE_CMD handler did not have these checks)
- Added new Define, <IfDefine>, <IfModule> configuration directives, new
  command-line option -D (a la Apache)
- Bug 1556 - Restructuring the way signals are handled, so that signal handling
             functions are executed synchronously, not asynchronously
- Bug 1463 - Added reporting of dispatching to auth handlers at debug level 6
- Bug 1258 - Added STOU command handler
- Bug 1534 - Added LFS support
- Bug 1647 - Changed unnecessary use of umode_t to mode_t in mod_ls.
- Bug 1650 - Mergedown bug with LsDefaultOptions directive fixed.
- Bug 1306 - Added a TimeoutSession directive that can be used to set a maximum
             time limit on an entire session.
- Bug 1643 - Cleaned up several source code files.
- Bug 1569 - Cygwin support, added README.cygwin
- Bug 1171 - Added handling backslash-escaped newlines in configuration files,
             so that a directive can be split across multiple lines using
             a trailing \ before the newline character.
- Removed the deprecated AllowChmod and ShowDotFiles configuration directives.
- Bug 1655 - Added support for a -n option when listing directories.
- Bug 1502 - Added a lingering_close function.  As discussed in the bug
             report, this may cause issues with some clients; keep an eye
             for this, as the timeout (ten minutes) may be too long or short.
- Bug 1664 - Changed mod_sql to decline UID-to-name resolution if a UID
             field has been configured to NULL; similarly for GID.
- Removed mod_quota.c due to bugs, lack of maintainership.  Consult
  http://bugs.proftpd.org for a list of the mod_quota bugs.
- Bug 1667 - Moved definition of USE_SHADOW, AUTO_SHADOW macros from command
             line into config.h, with the other macros.
- Bug 1628 - Added getgroups auth handler to mod_sql.  The lack of this was
             causing some DefaultRoot directives (those that relied on
             group-expressions) not be correctly honored, as mod_sql was
             not supplying the groups for the users.
- Bug 1543 - Change mod_sql to not remove embedded whitespace within a
             username, just to strip leading and trailing whitespace.

1.2.5 - Released 08-Jun-2002
----------------------------
New mod_sql (4.08)
- Bug 1379 - Changed mod_sql.c to use memset() instead of bzero()
- Bug 1576 - Checks for a NULL pointer in a border case involving use of
             SQLHomedirOnDemand
- Bug 1586 - Fixed bad assumption concerning row count involving SQL-provided
             group information
- Bug 1625 - Adds compatibility fix to mod_sql_mysql for older MySQL libraries
             (a function name changed in MySQL 3.23.14)

1.2.5rc3 - Released 30-May-2002
-------------------------------
New mod_ldap (2.8.6)
- Bug 1612 - Fixed logging of RFC931 usernames in xferlog
- Bug 1595 - Transfers that result in error conditions no longer cause
             the data connection to be closed prematurely via data_cleanup()
- Bug 1627 - Fixed bug in timer code where timers were being blocked
             indefinitely, manifesting as non-functioning idle timeouts
- Bug 1521 - Cleanup of function prototypes
- Bug 1379 - Changing remaining bzero/bcopy occurrences to memset/memcpy
- Bug 1394 - ftpstats program is not working

1.2.5rc2 - Released 13-May-2002
-------------------------------
- Added Andrew Houghton to the credits
- Added in the new format FAQ
- Bug 1580 - Minor additions to the RPM spec file to allow RPMs to be built
             by non-root users.
- Bug 1546 - PF_ARGV_WRITABLE, PF_ARGV_WRITEABLE are used mixed.  Fixed to
             use PF_ARGV_WRITEABLE consistently (less changes to make).
- Bug 1608 - src/dirtree.c produces two unnecessary warnings.  Fixed to
             cast to mode_t for initialization of variables.
- Bug 1610 - compiling mod_core.c gives an unneeded/dazzling msg
- Removed legacy documentation, updated licence template, licence update
  in ftp.h to include the SSL clause.  Updated CREDITS (ML)
- New mod_ldap (2.8.3)
- Bug 1544 - Daemon does not switch to configured User/Group identity in
             <VirtualHost> as documented
- Bug 1581 - Changed Hide{User,Group} directive to use pointers for
             proper handling of uid_t/gid_t types
- Migrated to the new form of the directive list from the pdd sgml sources
  (ML)
- Bug 1563 - Moved checking for bad address lookup up, to prevent segfault
             when using MasqueradeAddress
- Bug 1567 - Fixed parsing of AuthAliasOnly to honor Boolean parameter
- Bug 1579 - the contrib RPM init.d script make inappropriate use of
             ftpshut in a few cases
- Bug 1588 - Examined return value of inet_get_conn_info() to prevent
             segfaults for ephemeral TCP connections
- Bug 1570 - Changed MasqueradeAddress context checks in code to match
             docs
- Bug 1601 - RNTO handler did not properly cleanup after itself in an
             error condition, tickling a later segfault
- Bug 1523 - Amended fix for this bug to include a pool that should prevent
             memory leaks for long-running daemons
- Bug 1566 - Changed OpenBSD-specific macro checks to allow for proper
             use of sockets
- Bug 1578 - RootLogin's configuration directive handler did not properly
             set the mergedown flag
- New mod_wrap (1.2.3)
- Bug 1509 - removed contrib/genuser.pl (per TJ)
- Bug 1509 - added contrib/ftpasswd utility script (contributed by TJ)
- Bug 1318 - sendfile() semantics incorrect under Linux
- Bug 1450 - Timers removed immediately/alarm() return no longer used for
             timing
- Bug 1446 - DefaultServer overrides SocketBindTight
- Bug 1378 - Replace alloca stuff in glibc-glob.c with something more standard
- Bug 1498 - <Limit LOGIN> block failing with mod_ldap
- Bug 1381 - include/glibc-glob.h fix for Tru64 UNIX
- Bug 1465 - can't bind to port that hasn't been closed by forked child
             process
- Bug 1379 - replace bzero/bcopy with memset/memcpy
- Bug 1476 - doc updates
- Bug 1520 - security checks for TransferLogs
- Bug 1435 - AccessDenyMsg for <Anonymous> not working
- Bug 1492 - Bad interaction between HiddenStor and UserOwner
- Bug 1493 - incorrect parsing of AuthUserFile
- Bug 1485 - Adds CF_MERGEDOWN_MULTI config_rec flag
- Bug 1459 - server fails to send response in some cases
- Bug 1533 - use memset correctly
- Bug 1517 - doc update
- Bug 1461 - modules/mod_unixpw.c pw_getgroups() makes dangerous assumption
- Bug 1512 - Minor credentials cleanups
- Bug 1516 - wrong response to CDUP/XCUP/XCWD
- Bug 1451 - add_config_param_str() no longer uses permanent_pool
- Bug 1523 - umask allocation in <Global> moved to permanent_pool
- Bug 1380 - updated getopt library for Tru64/AIX
- Bug 1468 - segfault with empty .ftpaccess
- Bug 1445 - PID file contents change when attempting to start
             the daemon a second time
- Bug 1539 - losing SGID bit on created directories w/ {User,Group}Owner
             in effect
- Bug 1537 - doc update

1.2.5rc1 - Released 18-Dec-2001
-------------------------------
- New mod_sql (4.07)
- New mod_wrap (1.2.2)
- New mod_ldap (2.8.1)
- New Directive: UseGlobbing, allows glibc-based filepath globbing
  to be disabled.
- Bug 1113 - Make.rules for HPUX incorrectly generated
- Bug 1334 - (should have been in 1.2.4, but was missed somehow)
             MaxClients none in VirtualHost forbids connect
- Bug 1368 - umask bug is hopefully squashed for good
- Bug 1389 - fixed hang on PWD
- Bug 1355 - Added POST_CMD_ERR handler to API
- Bug 1396 - DenyFilter works only in server config scope
- Bug 1410 - SIGIO now conditionally compiled
- Bug 1281 - Improper checking of server context
- Bug 1364 - Immediate chown() after file creation
- Bug 1415 - Change allowed contexts for Include
- Bug 1430 - Possible bad handling of Directory contexts
- Bug 1426 - sigsegv on `ls ///////////'
- Bug 1360 - Add getgroups abstraction for auth modules
- Bug 1289 - Increase information passed to timer callbacks
- Bug 1341 - Bad tracking of forked processes
- Bug 1400 - Improper use of MODRET_HASDATA macro
- Bug 1416 - PidFile in <Global> context is unnecessary, even wasteful
- Bug 1429 - Trivial fixes to dispatch reporting
- Bug 1419 - Remove unnecessary colons from PRIVS_ macros
- Bug 1418 - Slight change to exithandler handling to allow module
             finalization slot
- Bug 1392 - Added LOG_CMD_ERR cleanup handler for LIST/NLST/RETR/
             STOR/APPE/STOU, to defer clearing of transfer counters.
- Bug 1391 - ABOR handler now clears session.xfer
- Check retr_file for validity when RESToring

1.2.4 - Released 19-Oct-2001
----------------------------
Ooops.  1.2.3 was released with a bug that breaks Umask on
certain platforms.  This results in files being mode 0.
- Bug 1348 - Fix for mode 0 problem

1.2.3 - Released 18-Oct-2001
----------------------------
PASS argument now intentionally hidden in the proctitle.
- Bug 1242 - More verbose logging of regex evaluations
- Bug 1343 - Better reporting of command dispatching
- Bug 1335 - Documentation patch
- Bug 1334 - MaxClients none in <VirtualHost> now works
- Bug 1344 - QUIT now properly logged.
- Bug 1247 - Allow/Deny now bahave as in <1.2.2 (multiple lines work)
- Bug 1327 - AllowForeignAddress now merges down
- Bug 1280 - datatype fixups
- Bug 1311 - DirFake* can no longer raise sigsegv
- Bug 1331 - Reverse DNS is now forward checked for security
- Bug 1305 - limits.h is now included if present

1.2.2 - Released 17-Aug-2001
----------------------------
README.mod_sql update from author
new mod_sql from author
- Bug 1285 - Documentation updates
- Bug 1278 - pedantic fix to access_check()
- Bug 1266 - Use of APPEnd could corrupt files
- Bug 1286 - mod_ls displays set[ug]id bits
- Bug 1145 - DirFakeUser now applies to STAT
- Bug 1216 - xferlog man page update
- Bug 1111 - INSTALL update
- Bug 1262 - Doc update
- Bug 1217 - Doc update
- Bug 1187 - Upstream update to mod_quota
- Bug 1232 - UserOwner no longer performs chgrp
- Bug 1219 - compilation fix under gcc 3.0
- Bug 1230 - Portability fix for Sol 8 (sparcv9)
- Bug 1169 - Fix bug introduced by 1098, breaking DefaultRoot other
  than "~*"
- Bug 1234 - ABOR now always returns 226 (as per RFC959)
- New mod_sql from upstream maintainer

1.2.2rc3 - Released 19-Jun-2001
-------------------------------
- Bugs 1164,1020,1134,1190,1207
  Documentation updates
- Bug 1215 - Removed setpgid()/setpgrp() from fork_server()
- Bug 1145 - DirFakeUser can display current logged in user
- Bug 1210 - Possible silent truncation in net-ascii mode
- Bug 1212 - special files (devices, etc) didn't show up in directory
  listings.
- Bug 1189 - (again) <Directory> dups allowed in <Anonymous>
- Bug 1155 - non rfc behavior on filenames with spaces
- Bug 1193 - Error "~" processing while renaming files
- Bug 1203 - negation ('!') notation in Allow/Deny ACL broken
- Bug 1161 - %F magic cookie now displays free space on cwd
- Bug 1151 - Allow <Limit> searching in vhost or main server conf
- Copyright/License updated to allow linking to OpenSSL
- Bug 1183 - Removed duplicate find_class() call
- Bug 1189 - <Directory> duping checked for
- Bug 1185 - symlinks in homedirs now resolved at login
- Bug 1149 - Patch to contrib RPM init script
- Bug 1132 - Compilation fix for glibc 2.0
- Bug 1201 - Modifications to contrib/xferstats.holger-preiss
- Bug 1090 - {Allow,Deny}Filter Errors now *really* logged
- New mod_sql (and friends) from upstream maintainer
- Bug 1175 - GNU HURD portability
- Bug 1176 - PWD/XPWD can now be <Limit>ed
- Bug 1177 - mod_readme moved to contrib/
- Bug 1155 - HPUX portability cleanup
- Bug 1172 - Compiler clean for getopt code.
- Bug 1170 - Compiler cleanup for pr_fnmatch code.
- Bug 1169 - Better handling of DefaultRoot/DefaultChdir
- Bug 1168 - variable definitions moved from proftpd.h to main.c
- Bug 1160 - BSD root socket semantics needed for svr4.2mp;UX/4800
- Bug 1156 - USER command now takes an argument with spaces in it
- Bug 1152 - Off-by-one in the PassivePorts code
- Bug 1137 - NLST displayed hidden files

1.2.2rc2 - Released 20-Apr-2001
-------------------------------
The `AllowChmod' directive has been deprecated, and will not work
consistently.  Use <Limit SITE_CHMOD> instead.

- Bug 1112 - Compilation fix for IRIX 6.2.
- Bug 1128 - Fixed possibled Linux sendfile() corruption issue.
- Bug 1093 - Checking for world writable log files and symlinks.
- Bug 1094 - AuthUserFile/AuthGroupFile disallow relative paths.
- Bug 1096 - Case sensitivity issues in config, better checking of
  RLimit* directive arguments.
- Bug 1090 - AllowFilter/DenyFilter now logs correctly.
- Bug 1119 - glibc-glob compilation issue on IRIX6.
- Bug 1090 - ExtendedLog should now report ALL events (even errors)

1.2.2rc1 - Released 24-Mar-2001
-------------------------------
- Bug 1085 - Better logging of "User is not a UserAlias" and "Can't find
  user."
- Bug 1043 - Fixed possible infinite loop in bandwidth throttling code.
- New RLimit* directives used to control resource usage on support platforms.
- Bug 1075 - Sub-contexts (<Directory>, etc) weren't being fully copied from
  <Global> to vhosts.
- Bug 1049 - New User/Groups weren't being seen after startup w/out a SIGHUP.
- Bug 1066 - new GNU glob() and friends, which properly limits recursion and
  avoids DoS issues.  Built-in glob support is now always compiled in to
  proftpd regardless of libc support on build platform.
- New directive "MasqueradeAddress", used to emit a "fake" (non-interface) IP
  in server ident, magic cookies and PASV commands.  Useful for firewalled or
  NAT'd networks that are not FTP aware.
- Bug 1044 - New directive "AccessDenyMsg", works just like AccessAllowMsg,
  but does the obvious.
- Bug 1055 - Not really a bug, but still .. ftpwho/ftpcount now attempt to
  scan proftpd.conf looking for ScoreboardPath, if all else fails
- Bug 1042 - <Directory /> arbitrarily not matching.

1.2.1 - Released 01-Mar-2001
----------------------------
- A relatively major issue was discovered with session.groups which may cause
  any group-expressions inside of <Limit> (DenyGroup, etc) to malfunction.
  This is the primary reason for the 1.2.1 release.
- Default CFLAGS changed from "-g3 -O6" to "-O2" because it is reported
  that -O6 is highly experimental, and including debugging really isn't all
  the useful, as someone _really_ interested in debugging can edit Make.rules.
- Defining classes without an explicit "Classes On" now generates a log
  warning.
- New mod_sql and mod_ldap from their respective maintainers.

1.2.0-final - Released 26-Feb-2001
----------------------------------
- Numerous additional bug fixes from Bugzilla.  See http://bugs.proftpd.org
  for more info.
- New and updated README.* and INSTALL.
- initgroups() support has been removed, it will be re-added in 1.3 after we
  have proper modular support in authentication modules.
- mod_sql.c, mod_sql_mysql.c and mod_sql_postgres.c back in, with a new
  maintainer (replacements for mod_sqlpw and friends).
- instead of using kill(pid,SIGCONT) to determine if scoreboard pids are
  correct, proftpd now uses kill(pid,0) which should be a lot lighter on
  heavy-load systems.  Thanks to Rob Schulhof <rrs@digisle.net> for pointing
  out that kill(pid,0) is both valid AND useful. ;) Also removed some
  completely useless and redundant /proc stat code which did the same thing
  as kill(pid,0) on linux systems.
- logging to file (via SystemLog) is now done with a single write instead of
  two in order to be atomic.

1.2.0rc3 - Released: 05-Feb-2001
--------------------------------
- mod_sqlpw.c, mod_mysql.c and mod_pgsql.c have been REMOVED from the
  distribution.  They are currently unmaintained and have numerous bugs.
  If any kind soul <grin> is interested in maintaining them, they may be
  brought back into a future version of proftpd.
- sendfile now defaults to off, use --enable-sendfile at configure
  time to enable.  Additionally, sendfile is probably fixed.
- initgroups/getgroups new defaults to off, use --enable-initgroups at
  configure time to enable (mainly useful for large systems).  Be careful,
  though, as initgroups/getgroups breaks module handling and will not work
  in conjunction with other third-party modules (mod_sqlpw, etc).
- Passive FTP works properly now (was broken in RC2).
- Compilation problems fixed on some obscure platforms.
- PAM authentication finally works again on Solaris (due to an annoying bug in
  Solaris).
- Added the DeleteAbortedStores directive.
- Fixed a minor bug in SITE HELP.
- Eliminated a race when logging in with MaxClients.
- AllowChmod defaults to 'on' now for simplicity and compatibility.
- Honor ExtendedLog NONE.
- Added SyslogLevel directive.
- Added --with-includes option to configure.
- Added --with-libraries option to configure.
- On systems with wtmpx, don't use wtmp at all.
- Handle files that begin with ~ properly.
- Documentation updated for PAM on FreeBSD operating systems.
- NUMEROUS other bug fixes, including many security issues

1.2.0RC2 - Released: 27-Jul-2000
--------------------------------
- Made sure ServerUseReverseDNS was honored.
- Compile problems on various problems.
- Added descriptions for more errors to be more RFC compliant.
- UID/GID handling is more portable now on systems with unusual UID/GID sizes.
- PAM handles should be persistent across jailed environments.
- Various additions to configure to make it more portable and correct.
- AllowChmod works properly now.
- HP/UX sendfile support.
- Cleaned up configure and supporting files.

1.2.0RCl - Released: 11-Jul-2000
--------------------------------
- Fixed a bug in mod_ls that could cause a crash.
- Fixed a minor bug related to group permissions.
- Fixed a bug in calculating file system size when using statvfs.
- Fixed a bug when a 'TYPE L' directive is passed improperly.
- Fixed Umask directive handling in directories.
- Changed bandwidth throttling to use select() instead of usleep() to work
  better across platforms.
- Updated mod_ldap to 2.5.2.
- Environment is now preserved before trying anything fancy with set_proc_title.
- Warn a user if an invalid class is specified in ExtendedLog.
- Logging of transfer times is more precise now.
- mod_quota now comes with ProFTPD in the contrib directory.
- FreeBSD 4.0 support.
- Unixware support.
- Updated config.guess and config.sub to reflect new platforms.
- Added a %k directive to DisplayQuit that shows a more user-friendly count of
  data transferred (ie: 23MB, 1.2GB, etc.).
- Added a -t option to ProFTPD to allow syntax testing of a config file.
- Made config file errors more useful by giving the filename and line number of
  the error.
- Added %A, %F, and %m directives to LogFormat to allow for the creation of
  CLF-style logs.
- Portability fixes to mod_tar.
- Timezone is preserved across jailed environments now.
- Slightly optimized directory listing/sorting in mod_ls as an interim measure.
  mod_ls will be rewritten entirely in 1.3.
- Added a -L option to mod_ls, so things like mirror work properly with
  symbolic links.
- Fixed the 'password shows up where username should be' problem with MySQL
  authentication.
- Fixed a potential security problem in setproctitle-enabled systems.
- Documented a buffer issue with CustomLog -- This will be entirely rewritten
  in 1.3.
- Fixed a potential buffer problem in mod_ls.
- Clarified syslog message information in INSTALL.
- ProFTPD will now generate a PID file in standalone operation.
- DisplayReadme now accepts patterns.
- Added AllowChmod directive.
- Allow comments and blank lines in password files.
- *snprintf emulation was incomplete on Solaris and other platforms with no
  *snprintf implementation.
- PAM now properly registers and closes a session, conforming closer to the PAM
  specification.
- More documentation updates.
- Fix a permissions display problem under certain circumstances.
- Minor fixes to classes support.
- AllowForeignAddress now applies to passive connections as well.
- Major performance upgrade to groups initialization.  Those that have large
  groups shouldn't see the 'hangs forever on login' problems.
- Fixed GroupOwner's semantics and added the related UserOwner directive.
- Added SQLKey, SQLKeyField, and SQLAuthoritative to mod_sql.
- Fixed access checks for LIST and NLST.
- Cleaned up use of '.' and '..' in mod_ls.
- Fixed a case where ServerUseReverseDNS wasn't being honored.

1.2.0pre10 - Released: 17-Jan-2000
----------------------------------
- sendfile() handles errors and non-optimal conditions The Right Way(tm).
- install_group works right in warped cases of having more than one GID 0
  group defined.  No, don't ask. :)
- sendfile() doesn't log spurious messages unless it's in debug mode now.
- A meaningful error is now generated with bad group files.
- Complex group permissions work correctly now, where they did not in a
  rare case.
- Updated included version of mod_ldap.
- Bandwidth and sendfile() use are now mutually exclusive.
- Corrected minor log issues.
- Fixed various compilation issues on various platforms (isn't this vague :)).
- More informative error messages.
- Minor semi-Y2K issue in mod_readme fixed (don't ask...look at the code :)).
- Corrected error messages on most commands in cases where an invalid number
  of arguments are specified.
- An error message is now generated when ~ expansion is meaningless.
- Invalid host entries don't show up as (null) anymore.

1.2.0pre9 - Released: 27-Oct-1999
---------------------------------
- New support for BSD sendfile() semantics.
- sendfile() deprecates politely on Linux 2.0.x.
- AuthPAMAuthoritative now defaults to False.  This should clear up any
  confusion on using PAM with AuthUserFile and friends.
- Removed Bandwidth from the documentation.
- Fixed a rare segfault in mod_auth.
- Logging has changed slightly to be more informative and more consistent.
    All messages that get logged are now preceded with
    <virtualhost> (remote host[remote ip]).
- mod_ldap for authentication against LDAP directories is now in place.
- ftpwho/ftpcount -- a grammatical error corrected, and they now build
    as separate binaries.
- Fixed the 'no names, just UIDs' bug.
- Added genuser.pl to facilitate AuthUserFile entry creation.
- Umask now takes an optional second argument, specifying a directory umask.
- Work around FreeBSD's broken setpassent(), and a new option to override
    this in fixed versions of FreeBSD's libc (--enable-force-setpassent).
- Generate RPMs for both inetd and standalone versions of ProFTPD.
- Added AuthUsingAlias to allow for more fine-grain control of anonymous
    logins.
- Added support for 'TYPE L 8' and 'TYPE L 7' per RFC 959.
